import _isEmpty from 'lodash/isEmpty';
import React from 'react';
import styles from './styles.scss';


export default (function (_ref) {
  var placeholder = _ref.placeholder,
      type = _ref.type,
      isRequired = _ref.isRequired,
      textColor = _ref.textColor,
      backgroundColor = _ref.backgroundColor,
      icon = _ref.icon,
      onChange = _ref.onChange,
      isValid = _ref.isValid,
      inputValue = _ref.inputValue,
      name = _ref.name,
      placeholderColor = _ref.placeholderColor;

  var validField = isValid & isRequired || isRequired & inputValue === '';
  return React.createElement(
    'div',
    { className: styles.inputWrapper + ' chat-box', style: { backgroundColor: backgroundColor, color: textColor } },
    React.createElement('input', {
      spellCheck: 'false',
      style: {
        backgroundColor: backgroundColor,
        color: _isEmpty(inputValue) ? placeholderColor : textColor,
        border: '' + (validField ? '1px solid red' : 'none')
      },
      name: name,
      placeholder: placeholder,
      onChange: onChange
    }),
    React.createElement(
      'div',
      { style: { color: _isEmpty(inputValue) ? placeholderColor : textColor }, className: styles.icon },
      icon
    )
  );
});