import React from 'react';
import styles from './styles.scss';

export default (function (_ref) {
  var placeholder = _ref.placeholder,
      type = _ref.type,
      isRequired = _ref.isRequired,
      textColor = _ref.textColor,
      backgroundColor = _ref.backgroundColor,
      icon = _ref.icon,
      onChange = _ref.onChange,
      isValid = _ref.isValid,
      inputValue = _ref.inputValue;

  var validField = isValid & isRequired || isRequired & inputValue === '';
  return React.createElement(
    'div',
    { className: styles.inputWrapper, style: { backgroundColor: 'transparent', color: textColor } },
    React.createElement(
      'span',
      { className: styles.label },
      placeholder
    ),
    React.createElement('div', { className: styles.inputBackground, style: { background: textColor } }),
    React.createElement('input', {
      spellCheck: 'false',
      style: {
        backgroundColor: 'transparent',
        color: textColor,
        border: '' + (validField ? '1px solid red' : 'none')
      },
      onChange: onChange
    }),
    React.createElement(
      'div',
      { className: styles.icon },
      icon
    )
  );
});