import React from 'react';
import styles from './styles.scss';
import SVG from 'react-inlinesvg';
export default (function (_ref) {
  var iconBackgroundColor = _ref.iconBackgroundColor,
      iconSize = _ref.iconSize,
      iconSrc = _ref.iconSrc,
      iconTextColor = _ref.iconTextColor,
      svgSize = _ref.svgSize,
      onClick = _ref.onClick,
      numberOfNewMessages = _ref.numberOfNewMessages,
      handleHover = _ref.handleHover;

  var isShowBadge = numberOfNewMessages && numberOfNewMessages !== 0;
  return React.createElement(
    'div',
    {
      className: styles.minimumIcon,
      style: {
        color: '' + iconBackgroundColor,
        width: iconSize,
        height: iconSize
      },
      onClick: onClick && onClick,
      onMouseEnter: function onMouseEnter() {
        return handleHover && handleHover({ isHover: true });
      },
      onMouseLeave: function onMouseLeave() {
        return handleHover && handleHover({ isHover: false });
      }
    },
    React.createElement(
      'div',
      { className: styles.icon },
      React.createElement(SVG, {
        src: iconSrc,
        style: {
          color: '' + iconTextColor,
          width: svgSize
        }
      })
    ),
    React.createElement(
      'div',
      { style: { display: isShowBadge ? 'flex' : 'none', width: iconSize / 3, height: iconSize / 3 }, className: styles.badge },
      numberOfNewMessages
    )
  );
});