import _extends from 'babel-runtime/helpers/extends';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _get from 'lodash/get';
import React, { Component } from 'react';
import { connect } from 'react-redux';
import MinimumIcon from '../minimum-icon';
import Conversation from '../conversation';

var ChatBox = function (_Component) {
  _inherits(ChatBox, _Component);

  function ChatBox() {
    _classCallCheck(this, ChatBox);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  ChatBox.prototype.render = function render() {
    var _props = this.props,
        showChat = _props.showChat,
        isInConfigurationMode = _props.isInConfigurationMode,
        currentComponent = _props.demoData.currentComponent,
        numberOfNewMessages = _props.numberOfNewMessages;

    var isShowChat = showChat || isInConfigurationMode && currentComponent === 'chatbox';
    return React.createElement(
      'div',
      { style: { height: '100%', zIndex: '9999997' } },
      React.createElement(Conversation, _extends({ isShowChat: isShowChat }, this.props)),
      React.createElement(MinimumIcon, { props: this.props, numberOfNewMessages: numberOfNewMessages })
    );
  };

  return ChatBox;
}(Component);

export default connect(function (store) {
  return {
    showChat: _get(store, 'behavior.showChat'),
    numberOfNewMessages: _get(store, 'messages.numberOfNewMessages')
  };
})(ChatBox);