import React, { Suspense, lazy } from 'react';
var HeaderStyleOne = lazy(function () {
  return import('./style-one');
});
var HeaderStyleTwo = lazy(function () {
  return import('./style-two');
});
var HeaderStyleThere = lazy(function () {
  return import('./style-three');
});

export default (function (props) {
  var activeTheme = props.setting.activeTheme;


  return activeTheme === 'style-two' ? React.createElement(
    Suspense,
    { fallback: React.createElement('div', null) },
    React.createElement(HeaderStyleTwo, props)
  ) : activeTheme === 'style-three' ? React.createElement(
    Suspense,
    { fallback: React.createElement('div', null) },
    React.createElement(HeaderStyleThere, props)
  ) : React.createElement(
    Suspense,
    { fallback: React.createElement('div', null) },
    React.createElement(HeaderStyleOne, props)
  );
});