import _get from "lodash/get";
import React, { Component } from "react";
import styles from "./styles.scss";
import SVGClose from "../../../../icon/close.svg";
import SVGFile from "../../../../icon/file_general.svg";
import SVG from "react-inlinesvg";


export default (function (_ref) {
  var setting = _ref.setting,
      attachment = _ref.attachment,
      handleClickRemove = _ref.handleClickRemove;

  // console.log(attachment);
  var _ref2 = attachment || {},
      src = _ref2.src,
      type = _ref2.type,
      isImage = _ref2.isImage,
      base64 = _ref2.base64,
      name = _ref2.name;

  return React.createElement(
    "div",
    {
      className: styles.container,
      style: {
        width: !isImage ? "110px" : "55px",
        padding: !isImage ? "7px 10px 7px 10px" : "0px"
      }
    },
    isImage && base64 && React.createElement("img", { className: styles.imageAttachment, src: base64 }),
    !isImage && name && React.createElement(
      "div",
      { className: styles.fileAttachmentWrapper },
      React.createElement(
        "div",
        { className: styles.fileAttachmentIcon },
        React.createElement(SVG, { src: SVGFile, style: { width: "32.7px", height: "40.5px" } })
      ),
      React.createElement(
        "div",
        { className: styles.fileName },
        name
      )
    ),
    React.createElement(
      "span",
      {
        className: styles.iconClose,
        onClick: handleClickRemove,
        style: {
          backgroundColor: _get(setting, "screenConversation.rightSideBackgroundColor"),
          color: _get(setting, "screenConversation.rightSideTextColor")
        }
      },
      React.createElement(SVG, { src: SVGClose, style: { width: "7px", height: "7px" } })
    )
  );
});