import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _isEmpty from 'lodash/isEmpty';
import _get from 'lodash/get';
import React, { Component } from 'react';
import SVGPhoto from '../../../icon/photo.svg';
import SVGAttach from '../../../icon/attach.svg';
import styles from './styles.scss';

import SVG from 'react-inlinesvg';
import AttachmentList from '../components/attachment-list';
import Upload from 'rc-upload';

var StyleOne = function (_Component) {
  _inherits(StyleOne, _Component);

  function StyleOne() {
    _classCallCheck(this, StyleOne);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  StyleOne.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        setting = _props.setting,
        uploadFiles = _props.uploadFiles,
        inputValue = _props.inputValue,
        handleRemoveAttachment = _props.handleRemoveAttachment;

    var iconColor = _get(setting, 'screenForm.placeholderTextColor');

    return React.createElement(
      'div',
      { className: styles.inputContainer + ' bs-chatbox-input-container' },
      !_isEmpty(uploadFiles) && React.createElement(AttachmentList, { uploadFiles: uploadFiles, setting: setting, handleRemoveAttachment: handleRemoveAttachment }),
      React.createElement(
        'div',
        { className: styles.inputRow },
        React.createElement('textarea', {
          value: inputValue,
          placeholder: _get(setting, 'chatboxThemeSettings.commonSettings.send_message_placeholder'),
          onChange: this.props.handleOnChange,
          onKeyPress: function onKeyPress(e) {
            _this2.props.handleKeyPress(e);
          },
          style: {
            color: _isEmpty(inputValue) ? _get(setting, 'screenForm.placeholderTextColor') : _get(setting, 'screenForm.inputTextColor')
          }
        })
      ),
      React.createElement(
        'div',
        { className: styles.additionalFunctionRow },
        React.createElement(
          'div',
          { className: styles.left },
          React.createElement(
            'span',
            { className: styles.icon },
            React.createElement(
              Upload,
              { showUploadList: false, multiple: true, beforeUpload: this.props.handleBeforeUploadAttachments },
              React.createElement(SVG, {
                src: SVGAttach,
                style: {
                  width: '16.9px',
                  height: '17.6px',
                  color: iconColor
                }
              })
            )
          ),
          React.createElement(
            'span',
            { className: styles.icon },
            React.createElement(
              Upload,
              { showUploadList: false, multiple: true, beforeUpload: this.props.handleBeforeUploadAttachments },
              React.createElement(SVG, {
                src: SVGPhoto,
                style: {
                  width: '20.5px',
                  height: '17.6px',
                  color: iconColor
                }
              })
            )
          )
        ),
        React.createElement(
          'div',
          { className: styles.right },
          React.createElement(
            'span',
            {
              className: styles.btnSend,
              onClick: this.props.handleClickBtnSend,
              style: {
                backgroundColor: _get(setting, 'screenConversation.rightSideBackgroundColor'),
                color: _get(setting, 'screenConversation.rightSideTextColor')
              }
            },
            'Send'
          )
        )
      )
    );
  };

  return StyleOne;
}(Component);

export { StyleOne as default };