import _get from 'lodash/get';

import React from 'react';
import styles from '../../offline-status.scss';
import StartButton from '../../../user-info-form/btn-start-conversation';

export default (function (_ref) {
  var setting = _ref.setting,
      onStartConversation = _ref.onStartConversation;

  return React.createElement(
    'div',
    { className: styles.content },
    React.createElement(
      'div',
      { className: styles.img },
      React.createElement('img', { src: 'https://storage.googleapis.com/bs-production-public/assets/widgets/bot_profilepic%402x.png' })
    ),
    React.createElement(
      'span',
      {
        style: {
          color: '' + (_get(setting, 'screenOffline.on.title_color') || _get(setting, 'screenConversation.rightSideBackgroundColor'))
        },
        className: styles.title
      },
      _get(setting, 'screenOffline.on.title')
    ),
    React.createElement(
      'span',
      {
        style: {
          color: '' + (_get(setting, 'screenOffline.on.title_color') || _get(setting, 'iconBackgroundColor'))
        },
        className: styles.description
      },
      _get(setting, 'screenOffline.on.description')
    ),
    React.createElement(
      'div',
      {
        className: styles.startChat,
        onClick: function onClick() {
          onStartConversation && onStartConversation(null);
        }
      },
      React.createElement(StartButton, { setting: setting, label: _get(setting, 'screenOffline.on.start_chat_label') })
    )
  );
});