import _isEmpty from 'lodash/isEmpty';
import _get from 'lodash/get';

import React, { useState } from 'react';
import styles from '../../offline-status.scss';
import StartButton from '../../../user-info-form/btn-start-conversation';

export default (function (_ref) {
  var setting = _ref.setting,
      onStartConversation = _ref.onStartConversation;

  var _useState = useState(''),
      message = _useState[0],
      setMessage = _useState[1];

  return React.createElement(
    'div',
    { className: styles.content },
    React.createElement(
      'span',
      {
        style: {
          color: '' + (_get(setting, 'screenOffline.off.title_color') || _get(setting, 'screenConversation.rightSideBackgroundColor'))
        },
        className: styles.title
      },
      _get(setting, 'screenOffline.off.title')
    ),
    React.createElement(
      'span',
      {
        style: {
          color: '' + (_get(setting, 'screenOffline.off.title_color') || _get(setting, 'iconBackgroundColor'))
        },
        className: styles.description
      },
      _get(setting, 'screenOffline.off.description')
    ),
    React.createElement('textarea', {
      className: styles.leaveMessage,
      value: message,
      placeholder: _get(setting, 'screenOffline.off.leave_message_placeholder') || 'Your message',
      style: {
        color: !_isEmpty(message) ? _get(setting, 'screenForm.inputTextColor') : _get(setting, 'screenForm.placeholderTextColor'),
        backgroundColor: _get(setting, 'screenForm.inputBackgroundColor')
      },
      onChange: function onChange(e) {
        return setMessage(e.target.value);
      }
    }),
    React.createElement(
      'div',
      {
        className: styles.startChat,
        onClick: function onClick() {
          onStartConversation && onStartConversation(message);
        }
      },
      React.createElement(StartButton, { setting: setting, label: _get(setting, 'screenOffline.off.start_chat_label') })
    )
  );
});