import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _get from 'lodash/get';
import React from 'react';
import styles from './offline-status.scss';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';

import { startConversation } from '../../../store/actions';
import { CloseIcon } from '../../icon';
import { BUTTON_STARTS } from '../../../commons/constants/websocket';
import WithoutAutomation from './components/without-automation';
import WithAutomation from './components/with-automation';

var OfflineStatus = function (_React$Component) {
  _inherits(OfflineStatus, _React$Component);

  function OfflineStatus() {
    _classCallCheck(this, OfflineStatus);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this));

    _this.onStartConversation = function (message) {};

    _this.state = { message: null };
    return _this;
  }

  OfflineStatus.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        setting = _props.setting,
        showedScreen = _props.showedScreen;

    return React.createElement(
      'div',
      { className: styles.container },
      showedScreen === 'off' && React.createElement(WithoutAutomation, {
        setting: setting,
        onStartConversation: function onStartConversation(message) {
          var isInConfigurationMode = _this2.props.isInConfigurationMode;

          if (isInConfigurationMode) return;
          _this2.props.actions.startConversation(BUTTON_STARTS.LEAVE_MESSAGE, {
            isWorkingDay: setting.isInOperatingHours,
            leaveMessage: message
          });
        }
      }),
      showedScreen === 'off_with_chatbot' && React.createElement(WithAutomation, {
        setting: setting,
        onStartConversation: function onStartConversation() {
          _this2.props.actions.startConversation(BUTTON_STARTS.CHAT_WITH_BOT, {
            isWorkingDay: setting.isInOperatingHours
          });
        }
      }),
      React.createElement(CloseIcon, { className: styles.closeIcon, iconTextColor: _get(setting, 'screenConversation.rightSideBackgroundColor') })
    );
  };

  return OfflineStatus;
}(React.Component);

export default connect(function (store) {
  return {
    userInfo: _get(store, 'behavior.userInfo')
  };
}, function (dispatch) {
  return {
    actions: bindActionCreators({ startConversation: startConversation }, dispatch)
  };
})(OfflineStatus);