import _get from 'lodash/get';
import React, { Component } from 'react';
import SVGSend from '../../../../icon/send.svg';

import SVG from 'react-inlinesvg';
import styles from './styles.scss';

export default (function (_ref) {
  var setting = _ref.setting,
      label = _ref.label;

  return React.createElement(
    'button',
    {
      type: 'submit',
      className: styles.button,
      style: {
        backgroundColor: _get(setting, 'screenConversation.rightSideBackgroundColor'),
        boxShadow: '0 1px 2px 0 rgba(0, 0, 0, 0.16)',
        border: 'none',
        borderRadius: '30px',
        height: '40px',
        width: 'fit-content',
        minWidth: '100%',
        fontFamily: 'Open Sans',
        display: 'flex',
        justifyContent: 'center',
        alignItems: 'center',
        fontWeight: '700',
        margin: 'auto',
        fontSize: '16px',
        color: '#fff',
        outline: 'none',
        boxSizing: 'border-box',
        cursor: 'pointer'
      }
    },
    label || _get(setting, 'chatboxThemeSettings.commonSettings.start_button_label'),
    React.createElement(SVG, {
      src: SVGSend,
      style: {
        width: '13.9px',
        height: '12px',
        marginLeft: '5px'
      }
    })
  );
});