import React, { useContext } from 'react';
import { useDispatch } from 'react-redux';
import { toggleChat } from '../../store/actions';
import WidgetContext from '../../widget-context';

export var CloseIcon = function CloseIcon(_ref) {
  var iconTextColor = _ref.iconTextColor,
      className = _ref.className,
      style = _ref.style;

  var dispatch = useDispatch();

  var _useContext = useContext(WidgetContext),
      setting = _useContext.setting;

  return React.createElement(
    'svg',
    {
      xmlns: 'http://www.w3.org/2000/svg',
      version: '1.1',
      id: 'Capa_1',
      x: '0px',
      y: '0px',
      width: '512px',
      height: '512px',
      viewBox: '0 0 357 357',
      style: { alignSelf: 'center' },
      className: className,
      onClick: function onClick() {
        return dispatch(toggleChat(setting));
      }
    },
    React.createElement(
      'g',
      null,
      React.createElement(
        'g',
        { id: 'clear' },
        React.createElement('polygon', {
          points: '357,35.7 321.3,0 178.5,142.8 35.7,0 0,35.7 142.8,178.5 0,321.3 35.7,357 178.5,214.2 321.3,357 357,321.3     214.2,178.5   ',
          fill: iconTextColor || '#FFFFFF'
        })
      )
    ),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null),
    React.createElement('g', null)
  );
};