import _get from 'lodash/get';
import React, { useState } from 'react';
import styles from './styles.scss';

import Power from '../power';
import Button from '../button';
import SendInfoForm from '../leave-info';
import { CloseCallIcon } from '../../../icon';
import { useSelector } from 'react-redux';

export default (function (_ref) {
  var setting = _ref.setting,
      status = _ref.status,
      handleCallAgain = _ref.handleCallAgain;

  var _useState = useState(false),
      wannaLeaveInfo = _useState[0],
      setWannaLeaveInfo = _useState[1];

  var alreadySaveInfo = useSelector(function (store) {
    return _get(store, 'behavior.alreadySubmitUserInfo');
  });

  var onClickCallAgain = function onClickCallAgain() {
    handleCallAgain && handleCallAgain();
  };

  return React.createElement(
    'div',
    { className: styles.container },
    wannaLeaveInfo && !alreadySaveInfo ? React.createElement(SendInfoForm, { setting: setting }) : React.createElement(
      'div',
      { className: styles.content },
      React.createElement(
        'span',
        { style: { color: _get(setting, 'screenConversation.rightSideBackgroundColor') }, className: styles.title },
        status === 'Canceled' ? _get(setting, 'callThemeSettings.commonSettings.busy_line_admin_receive_tile') : _get(setting, 'callThemeSettings.commonSettings.busy_line_title')
      ),
      !alreadySaveInfo && React.createElement(
        'span',
        { className: styles.description },
        _get(setting, 'callThemeSettings.commonSettings.busy_line_description')
      ),
      React.createElement(
        'div',
        { style: { marginBottom: '24px' } },
        !alreadySaveInfo && React.createElement(Button, {
          setting: setting,
          onClick: function onClick() {
            return setWannaLeaveInfo(true);
          },
          text: _get(setting, 'callThemeSettings.commonSettings.leave_infomtion_label'),
          isBorder: true,
          width: '100%'
        })
      ),
      React.createElement(
        'div',
        null,
        React.createElement(Button, {
          setting: setting,
          callIcon: true,
          color: '#fff',
          text: _get(setting, 'callThemeSettings.commonSettings.call_again_label'),
          onClick: onClickCallAgain,
          width: '100%'
        })
      ),
      React.createElement(
        'div',
        { className: styles.power },
        React.createElement(Power, { setting: setting })
      )
    ),
    React.createElement(CloseCallIcon, { iconTextColor: _get(setting, 'screenConversation.rightSideBackgroundColor'), className: styles.closeIcon })
  );
});