import _extends from 'babel-runtime/helpers/extends';
import _get from 'lodash/get';
import React from 'react';

import styles from './styles.scss';
import SVG from 'react-inlinesvg';
import call from '../../../../icon/call.svg';
import SVGSend from '../../../../icon/send.svg';
import '../overwrite.css';
import Loading from '../../../../../commons/components/loading';

export default (function (props) {
  var setting = props.setting,
      onClick = props.onClick,
      text = props.text,
      callIcon = props.callIcon,
      isBorder = props.isBorder,
      sendIcon = props.sendIcon,
      isLoading = props.isLoading,
      isAccessButton = props.isAccessButton,
      width = props.width,
      color = props.color;

  return React.createElement(
    'div',
    null,
    !isAccessButton ? React.createElement(
      'div',
      { style: { width: 'auto', height: '38px' }, className: 'boostcrm-call-button' },
      React.createElement(
        'button',
        { type: 'submit', onClick: onClick, className: styles.theme2Container },
        React.createElement(
          'div',
          {
            className: styles.button,
            style: _extends({}, isBorder ? {
              border: '1px solid ' + _get(setting, 'screenConversation.rightSideBackgroundColor'),
              color: _get(setting, 'screenConversation.rightSideBackgroundColor')
            } : { backgroundColor: _get(setting, 'screenConversation.rightSideBackgroundColor') }, {
              width: width
            })
          },
          !isLoading && callIcon && React.createElement(
            'div',
            { className: styles.icon },
            React.createElement(SVG, { src: call })
          ),
          isLoading && React.createElement(
            'div',
            { className: styles.icon },
            React.createElement(Loading, { color: color || _get(setting, 'screenConversation.rightSideBackgroundColor') })
          ),
          text,
          !isLoading && sendIcon && React.createElement(
            'div',
            { style: { marginLeft: '5px' }, className: styles.icon },
            React.createElement(SVG, { src: SVGSend })
          )
        )
      )
    ) : React.createElement(
      'div',
      { className: 'boostcrm-call-button' },
      React.createElement(
        'button',
        { onClick: onClick, className: styles.theme2Container + ' ' },
        React.createElement(
          'div',
          { className: styles.accessButton, style: { backgroundColor: _get(setting, 'screenConversation.rightSideBackgroundColor') } },
          text
        )
      )
    )
  );
});