import _get from 'lodash/get';
import React from 'react';
import styles from './styles.scss';

import Header from '../header';
import Power from '../power';
import Button from '../button';

export default (function (_ref) {
  var handleGetPermission = _ref.handleGetPermission,
      setting = _ref.setting,
      isMobileMode = _ref.isMobileMode;

  var handleRequestAccessMicrophone = function handleRequestAccessMicrophone() {
    navigator.mediaDevices.getUserMedia({ audio: true }).then(function (mediaStream) {
      handleGetPermission && handleGetPermission({ isAllow: true });
      mediaStream.getTracks().forEach(function (track) {
        track.stop();
      });
    }).catch(function () {
      handleGetPermission && handleGetPermission({ isAllow: false });
    });
  };

  return React.createElement(
    'div',
    { className: styles.container },
    React.createElement(Header, { setting: setting, isMobileMode: isMobileMode }),
    React.createElement(
      'div',
      { className: styles.deviceSetting },
      React.createElement(
        'div',
        { className: styles.deviceStatus },
        React.createElement(
          'div',
          { className: styles.titleContent },
          React.createElement(
            'span',
            {
              className: styles.title,
              style: {
                color: _get(setting, 'screenConversation.rightSideBackgroundColor')
              }
            },
            _get(setting, 'callThemeSettings.commonSettings.using_microphone_text')
          )
        ),
        React.createElement(
          'div',
          { className: styles.buttonContent },
          React.createElement(
            'span',
            { style: { fontFamily: 'Open Sans' }, className: styles.button },
            _get(setting, 'callThemeSettings.commonSettings.access_microphone_text')
          )
        ),
        React.createElement(
          'div',
          { className: styles.allowButton },
          React.createElement(Button, {
            setting: setting,
            onClick: handleRequestAccessMicrophone,
            isAccessButton: true,
            callIcon: false,
            text: _get(setting, 'callThemeSettings.commonSettings.allow_microphone_label')
          })
        )
      )
    ),
    React.createElement(Power, { setting: setting })
  );
});