import _get from 'lodash/get';
import React, { Component } from 'react';
import styles from './styles.scss';

import { CloseCallIcon } from '../../../../icon';
import CallIcon from '../call-animation';

export default (function (_ref) {
  var setting = _ref.setting,
      isInConfigurationMode = _ref.isInConfigurationMode,
      demoData = _ref.demoData,
      isMobileMode = _ref.isMobileMode;

  var activeTheme = _get(setting, 'activeTheme');
  var iconTextColor = _get(setting, 'iconTextColor');

  return React.createElement(
    'div',
    {
      className: '' + styles.headerContainer,
      style: {
        background: _get(setting, 'iconBackgroundColor'),
        color: iconTextColor,
        borderRadius: isMobileMode ? '0px' : ' 18px 18px 0 0'
      }
    },
    React.createElement(CallIcon, { bgColor: _get(setting, 'screenConversation.rightSideBackgroundColor'), iconColor: '#fff' }),
    React.createElement(
      'div',
      { className: styles.textContent },
      React.createElement(
        'div',
        { className: styles.headerRow },
        React.createElement(
          'span',
          {
            style: {
              color: iconTextColor
            }
          },
          _get(setting, 'callThemeSettings.' + activeTheme + '.header.header_text_1')
        )
      )
    ),
    React.createElement(CloseCallIcon, { className: styles.closeIcon, iconTextColor: iconTextColor })
  );
});