import _get from 'lodash/get';
import styles from './styles.scss';
import React, { Component, useState } from 'react';

import Power from '../power';
import Button from '../button';
import SendInfoForm from '../leave-info';
import { CloseCallIcon } from '../../../icon';
import call from '../../../icon/call.svg';
import SVG from 'react-inlinesvg';
import { useSelector } from 'react-redux';

var getBorderRadiusValue = function getBorderRadiusValue(activeTheme) {
  if (activeTheme === 'style-one') {
    return '0px';
  }
  if (activeTheme === 'style-two') {
    return '30px';
  }
  return '10px';
};

export default (function (props) {
  var setting = props.setting;

  var _useState = useState(false),
      wannaLeaveInfo = _useState[0],
      setWannaLeaveInfo = _useState[1];

  var phoneNumber = _get(setting, 'callComponent.phoneNumber');
  var activeTheme = _get(setting, 'activeTheme');
  var borderRadius = getBorderRadiusValue(activeTheme);
  var alreadySaveInfo = useSelector(function (store) {
    return _get(store, 'behavior.alreadySubmitUserInfo');
  });

  return React.createElement(
    'div',
    { className: styles.container },
    wannaLeaveInfo && !alreadySaveInfo ? React.createElement(SendInfoForm, { setting: setting, isNoSupport: true, onCloseForm: function onCloseForm() {
        return setLeaveInfo(false);
      } }) : React.createElement(
      'div',
      { className: styles.content },
      React.createElement(
        'span',
        { style: { color: _get(setting, 'screenConversation.rightSideBackgroundColor') }, className: styles.title },
        _get(setting, 'callThemeSettings.commonSettings.no_support_title')
      ),
      !alreadySaveInfo && React.createElement(
        'span',
        { className: styles.description },
        _get(setting, 'callThemeSettings.commonSettings.no_spport_description')
      ),
      !alreadySaveInfo && React.createElement(Button, {
        setting: setting,
        onClick: function onClick() {
          return setWannaLeaveInfo(true);
        },
        text: _get(setting, 'callThemeSettings.commonSettings.no_support_label'),
        isBorder: true,
        width: '100%'
      }),
      phoneNumber && React.createElement(
        'div',
        { style: { marginTop: '24px' } },
        React.createElement(
          'a',
          {
            style: {
              background: _get(setting, 'screenConversation.rightSideBackgroundColor'),
              borderRadius: borderRadius
            },
            className: styles.phoneCallButton,
            href: 'tel:' + phoneNumber
          },
          React.createElement(SVG, { className: styles.icon, src: call }),
          phoneNumber
        )
      )
    ),
    React.createElement(Power, { setting: setting }),
    React.createElement(CloseCallIcon, { iconTextColor: _get(setting, 'screenConversation.rightSideBackgroundColor'), className: styles.closeIcon })
  );
});