import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _isEmpty from 'lodash/isEmpty';
import _get from 'lodash/get';
import React, { Component } from 'react';
import styles from './styles.scss';
import Header from '../header';
import Power from '../power';

import Button from '../button';

var PageStartCall = function (_Component) {
  _inherits(PageStartCall, _Component);

  function PageStartCall() {
    var _temp, _this, _ret;

    _classCallCheck(this, PageStartCall);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.handleChangeSpeaker = function (e) {
      var _this$props = _this.props,
          handleSelectDevices = _this$props.handleSelectDevices,
          selectedMicrophoneId = _this$props.selectedMicrophoneId;

      handleSelectDevices && handleSelectDevices(e.target.value, selectedMicrophoneId);
    }, _this.handleChangeMicrophone = function (e) {
      var _this$props2 = _this.props,
          handleSelectDevices = _this$props2.handleSelectDevices,
          selectedSpeakerId = _this$props2.selectedSpeakerId;

      handleSelectDevices && handleSelectDevices(selectedSpeakerId, e.target.value);
    }, _this.handleClickCall = function () {
      var _this$props3 = _this.props,
          handleStartCall = _this$props3.handleStartCall,
          selectedMicrophoneId = _this$props3.selectedMicrophoneId,
          selectedSpeakerId = _this$props3.selectedSpeakerId;

      handleStartCall && handleStartCall(selectedSpeakerId, selectedMicrophoneId);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  PageStartCall.prototype.render = function render() {
    var _props = this.props,
        selectedMicrophoneId = _props.selectedMicrophoneId,
        selectedSpeakerId = _props.selectedSpeakerId,
        callInfo = _props.callInfo;
    var _props2 = this.props,
        devices = _props2.devices,
        setting = _props2.setting,
        isMobileMode = _props2.isMobileMode;


    var speakers = (devices || []).filter(function (device) {
      return device.kind === 'audiooutput';
    });

    var microphones = (devices || []).filter(function (device) {
      return device.kind === 'audioinput';
    });

    selectedSpeakerId = selectedSpeakerId || (!_isEmpty(speakers) ? speakers[0].deviceId : undefined);
    selectedMicrophoneId = selectedMicrophoneId || (!_isEmpty(microphones) ? microphones[0].deviceId : undefined);

    return React.createElement(
      'div',
      { className: styles.container },
      React.createElement(Header, { setting: setting, isMobileMode: isMobileMode }),
      React.createElement(
        'div',
        { className: styles.content },
        React.createElement(
          'div',
          { className: styles.deviceSetting },
          React.createElement(
            'div',
            { className: styles.labelContainer },
            React.createElement(
              'div',
              { style: { color: _get(setting, 'screenConversation.rightSideBackgroundColor') }, className: styles.label },
              _get(setting, 'callThemeSettings.commonSettings.start_call__choose_your_input_device') || 'Choose your input device'
            )
          ),
          React.createElement(
            'div',
            { className: styles.deviceStatus },
            React.createElement(
              'select',
              { onChange: this.handleChangeMicrophone, value: selectedMicrophoneId },
              microphones.map(function (mic) {
                return React.createElement(
                  'option',
                  { key: mic.deviceId, value: mic.deviceId },
                  mic.label
                );
              })
            )
          )
        ),
        React.createElement(
          'div',
          { className: styles.btnCallWrapper },
          React.createElement(
            'div',
            {
              style: {
                width: '100%',
                paddingLeft: '39px',
                paddingRight: '39px'
              }
            },
            React.createElement(Button, {
              isLoading: _get(this.props, 'callInfo.callData.status') === 'Connecting',
              setting: setting,
              onClick: this.handleClickCall,
              callIcon: true,
              color: '#fff',
              text: _get(setting, 'callThemeSettings.commonSettings.call_now_label'),
              width: 'min-content'
            })
          )
        )
      ),
      React.createElement(Power, { setting: setting })
    );
  };

  return PageStartCall;
}(Component);

export { PageStartCall as default };