import _regeneratorRuntime from 'babel-runtime/regenerator';
import _asyncToGenerator from 'babel-runtime/helpers/asyncToGenerator';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import { wait } from '../../commons/utils';

var fibonacciNumbers = [0.5, 1, 2, 3, 5, 8, 13];

var WebRTC = function () {
  function WebRTC() {
    var _this = this;

    _classCallCheck(this, WebRTC);

    this.candidates = [];
    this.iceServers = [];
    this.gotRemoteStreamHandler = undefined;

    this._setRemotePeerConnectionInfo = function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(remotePeerConnectionInfo) {
        var _ref2, desc, candidates, _iterator, _isArray, _i, _ref3, candidate;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // console.log("_setRemotePeerConnectionInfo");
                _ref2 = remotePeerConnectionInfo || {}, desc = _ref2.desc, candidates = _ref2.candidates;

                if (!(!desc || !candidates)) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt('return');

              case 3:
                _context.next = 5;
                return _this.peerConnection.setRemoteDescription(new RTCSessionDescription(desc));

              case 5:
                _iterator = candidates, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();

              case 6:
                if (!_isArray) {
                  _context.next = 12;
                  break;
                }

                if (!(_i >= _iterator.length)) {
                  _context.next = 9;
                  break;
                }

                return _context.abrupt('break', 21);

              case 9:
                _ref3 = _iterator[_i++];
                _context.next = 16;
                break;

              case 12:
                _i = _iterator.next();

                if (!_i.done) {
                  _context.next = 15;
                  break;
                }

                return _context.abrupt('break', 21);

              case 15:
                _ref3 = _i.value;

              case 16:
                candidate = _ref3;
                _context.next = 19;
                return _this.peerConnection.addIceCandidate(new RTCIceCandidate(candidate));

              case 19:
                _context.next = 6;
                break;

              case 21:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();
  }

  WebRTC.prototype._resetProperties = function _resetProperties() {
    this.remoteStream = null;
    this.localStream = null;
  };

  WebRTC.prototype._convertCandidateToJSON = function _convertCandidateToJSON(candidate) {
    if (!candidate) return null;
    return {
      address: candidate.address,
      candidate: candidate.candidate,
      component: candidate.component,
      foundation: candidate.foundation,
      port: candidate.port,
      priority: candidate.priority,
      protocol: candidate.protocol,
      relatedAddress: candidate.relatedAddress,
      relatedPort: candidate.relatedPort,
      sdpMLineIndex: candidate.sdpMLineIndex,
      sdpMid: candidate.sdpMid,
      tcpType: candidate.tcpType,
      type: candidate.type,
      usernameFragment: candidate.usernameFragment
    };
  };

  WebRTC.prototype._initPeerConnection = function _initPeerConnection() {
    var _this2 = this;

    // console.log("_initPeerConnection:", this.iceServers);
    this.peerConnection = new RTCPeerConnection({
      iceServers: this.iceServers,
      iceTransportPolicy: 'all',
      iceCandidatePoolSize: '0'
    });

    this.peerConnection.ontrack = function (e) {
      // console.log("receive remote stream");
      // console.log("-----------------receive remote stream---------");
      _this2.remoteStream = e.streams[0];
      _this2.gotRemoteStreamHandler && _this2.gotRemoteStreamHandler(_this2.remoteStream);
    };

    // Some should read documents
    // https://www.html5rocks.com/en/tutorials/webrtc/infrastructure/#how-can-i-build-a-signaling-service
    // https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection
    // https://webrtc.github.io/samples/src/content/peerconnection/trickle-ice/
    // https://code.google.com/archive/p/coturn/wikis/turnserver.wiki
    this.peerConnection.onicegatheringstatechange = function () {
      // console.log(
      //   "onicegatheringstatechange: ",
      //   this.peerConnection.iceGatheringState
      // );
      // if (this.peerConnection.iceGatheringState !== "complete") {
      //   return;
      // }
    };

    this.peerConnection.onicecandidate = function (_ref4) {
      var candidate = _ref4.candidate;

      // console.log("onicecandidate:");
      candidate && _this2.candidates.push(_this2._convertCandidateToJSON(candidate));
    };

    this.peerConnection.onicecandidateerror = function (err) {
      // console.log("onicecandidateerror:", err);
    };

    this.peerConnection.oniceconnectionstatechange = function (e) {
      // console.log("ICE Event: ", e);
      // console.log(
      //   "iceConnectionState: ",
      //   this.peerConnection.iceConnectionState
      // );
    };
  };

  WebRTC.prototype._collectICECandicates = function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
      var maxWaitDurations, currentWaitTimeIndex, findRequiredICE, findSRFLX, findREPLAY, _iterator2, _isArray2, _i2, _ref6, ice;

      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              // console.log("_collectICECandicates at ", new Date());
              maxWaitDurations = fibonacciNumbers;
              currentWaitTimeIndex = 0;
              findRequiredICE = false;
              findSRFLX = false;
              findREPLAY = false;

            case 5:
              _context2.next = 7;
              return wait(maxWaitDurations[currentWaitTimeIndex] * 1000);

            case 7:
              _iterator2 = this.candidates, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();

            case 8:
              if (!_isArray2) {
                _context2.next = 14;
                break;
              }

              if (!(_i2 >= _iterator2.length)) {
                _context2.next = 11;
                break;
              }

              return _context2.abrupt('break', 23);

            case 11:
              _ref6 = _iterator2[_i2++];
              _context2.next = 18;
              break;

            case 14:
              _i2 = _iterator2.next();

              if (!_i2.done) {
                _context2.next = 17;
                break;
              }

              return _context2.abrupt('break', 23);

            case 17:
              _ref6 = _i2.value;

            case 18:
              ice = _ref6;

              if (ice.type === 'srflx') {
                findSRFLX = true;
              }

              if (ice.type === 'relay') {
                findREPLAY = true;
              }

            case 21:
              _context2.next = 8;
              break;

            case 23:
              findRequiredICE = findSRFLX && findREPLAY;
              ++currentWaitTimeIndex;

            case 25:
              if (!findRequiredICE && currentWaitTimeIndex < maxWaitDurations.length - 1) {
                _context2.next = 5;
                break;
              }

            case 26:
              if (findRequiredICE) {
                _context2.next = 28;
                break;
              }

              throw new Error();

            case 28:
              if (this) {
                _context2.next = 30;
                break;
              }

              return _context2.abrupt('return');

            case 30:
              return _context2.abrupt('return', { desc: this.desc, candidates: this.candidates });

            case 31:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function _collectICECandicates() {
      return _ref5.apply(this, arguments);
    }

    return _collectICECandicates;
  }();

  WebRTC.prototype._initUserMedia = function () {
    var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
      var _this3 = this;

      return _regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.prev = 0;
              _context3.next = 3;
              return navigator.mediaDevices.getUserMedia({
                audio: true
              });

            case 3:
              this.localStream = _context3.sent;

              this.localStream.getTracks().forEach(function (track) {
                // console.log("this.peerConnection.addTrack");
                _this3.peerConnection.addTrack(track, _this3.localStream);
              });
              _context3.next = 10;
              break;

            case 7:
              _context3.prev = 7;
              _context3.t0 = _context3['catch'](0);
              throw new Error(JSON.stringify({ message: 'Init User Media failed', code: '2' }));

            case 10:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, this, [[0, 7]]);
    }));

    function _initUserMedia() {
      return _ref7.apply(this, arguments);
    }

    return _initUserMedia;
  }();

  WebRTC.prototype._createOffer = function () {
    var _ref8 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
      return _regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              if (this) {
                _context4.next = 2;
                break;
              }

              return _context4.abrupt('return');

            case 2:
              _context4.next = 4;
              return this.peerConnection.createOffer({
                offerToReceiveAudio: 1
              });

            case 4:
              this.desc = _context4.sent;
              _context4.next = 7;
              return this.peerConnection.setLocalDescription(this.desc);

            case 7:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function _createOffer() {
      return _ref8.apply(this, arguments);
    }

    return _createOffer;
  }();

  WebRTC.prototype._createAnswer = function () {
    var _ref9 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
      return _regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              if (this) {
                _context5.next = 2;
                break;
              }

              return _context5.abrupt('return');

            case 2:
              _context5.next = 4;
              return this.peerConnection.createAnswer();

            case 4:
              this.desc = _context5.sent;
              _context5.next = 7;
              return this.peerConnection.setLocalDescription(this.desc);

            case 7:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function _createAnswer() {
      return _ref9.apply(this, arguments);
    }

    return _createAnswer;
  }();

  WebRTC.prototype.startCall = function () {
    var _ref10 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee7(iceServers) {
      var _this4 = this;

      return _regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              this.iceServers = iceServers;
              // console.log("startCall");
              return _context7.abrupt('return', new Promise(function () {
                var _ref11 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6(resolve, reject) {
                  var _ref12, desc, candidates;

                  return _regeneratorRuntime.wrap(function _callee6$(_context6) {
                    while (1) {
                      switch (_context6.prev = _context6.next) {
                        case 0:
                          _context6.prev = 0;

                          _this4._initPeerConnection();
                          _context6.next = 4;
                          return _this4._initUserMedia();

                        case 4:
                          _context6.next = 6;
                          return _this4._createOffer();

                        case 6:
                          _context6.next = 8;
                          return _this4._collectICECandicates();

                        case 8:
                          _ref12 = _context6.sent;
                          desc = _ref12.desc;
                          candidates = _ref12.candidates;

                          resolve([null, { desc: desc, candidates: candidates }]);
                          _context6.next = 17;
                          break;

                        case 14:
                          _context6.prev = 14;
                          _context6.t0 = _context6['catch'](0);

                          // ToDo: Could not collect ICE Candicates -> Leave some information for call back
                          reject([_context6.t0]);

                        case 17:
                        case 'end':
                          return _context6.stop();
                      }
                    }
                  }, _callee6, _this4, [[0, 14]]);
                }));

                return function (_x3, _x4) {
                  return _ref11.apply(this, arguments);
                };
              }()));

            case 2:
            case 'end':
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));

    function startCall(_x2) {
      return _ref10.apply(this, arguments);
    }

    return startCall;
  }();

  WebRTC.prototype.acceptCall = function () {
    var _ref13 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee9(remotePeerConnectionInfo) {
      var _this5 = this;

      return _regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              return _context9.abrupt('return', new Promise(function () {
                var _ref14 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee8(resolve, reject) {
                  var _ref15, desc, candidates;

                  return _regeneratorRuntime.wrap(function _callee8$(_context8) {
                    while (1) {
                      switch (_context8.prev = _context8.next) {
                        case 0:
                          _context8.prev = 0;

                          _this5._initPeerConnection();
                          _context8.next = 4;
                          return _this5._initUserMedia();

                        case 4:
                          _context8.next = 6;
                          return _this5._setRemotePeerConnectionInfo(remotePeerConnectionInfo);

                        case 6:
                          _context8.next = 8;
                          return _this5._createAnswer();

                        case 8:
                          _context8.next = 10;
                          return _this5._collectICECandicates();

                        case 10:
                          _ref15 = _context8.sent;
                          desc = _ref15.desc;
                          candidates = _ref15.candidates;

                          resolve([null, { desc: desc, candidates: candidates }]);
                          _context8.next = 19;
                          break;

                        case 16:
                          _context8.prev = 16;
                          _context8.t0 = _context8['catch'](0);

                          // ToDo: Could not collect ICE Candicates -> Leave some information for call back
                          reject([_context8.t0]);

                        case 19:
                        case 'end':
                          return _context8.stop();
                      }
                    }
                  }, _callee8, _this5, [[0, 16]]);
                }));

                return function (_x6, _x7) {
                  return _ref14.apply(this, arguments);
                };
              }()));

            case 1:
            case 'end':
              return _context9.stop();
          }
        }
      }, _callee9, this);
    }));

    function acceptCall(_x5) {
      return _ref13.apply(this, arguments);
    }

    return acceptCall;
  }();

  WebRTC.prototype.stopCall = function stopCall() {
    // console.log("stop Call");
    if (!this) return;
    this.localStream && this.localStream.getTracks().forEach(function (track) {
      track.stop();
    });

    if (this.peerConnection) {
      this.peerConnection.close();
      this.peerConnection = undefined;
    }

    this.candidates = [], this.desc = [];
  };

  WebRTC.prototype.onGotRemoteStreamHandler = function onGotRemoteStreamHandler(cb) {
    this.gotRemoteStreamHandler = cb;
  };

  WebRTC.prototype.updateRemotePeerConnection = function () {
    var _ref16 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee10(remotePeerConnectionInfo) {
      return _regeneratorRuntime.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              // console.log("updateRemotePeerConnection");
              this._setRemotePeerConnectionInfo(remotePeerConnectionInfo);

            case 1:
            case 'end':
              return _context10.stop();
          }
        }
      }, _callee10, this);
    }));

    function updateRemotePeerConnection(_x8) {
      return _ref16.apply(this, arguments);
    }

    return updateRemotePeerConnection;
  }();

  WebRTC.prototype.getLocalStream = function getLocalStream() {
    return this.localStream;
  };

  WebRTC.prototype.getRemoteStream = function getRemoteStream() {
    return this.remoteStream;
  };

  return WebRTC;
}();

export default new WebRTC();