import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _get from 'lodash/get';
import React, { Component } from 'react';
import Frame from 'react-frame-component';

import scrollIcon from '../icon/scroll_top.svg';
import WidgetIcon from '../../commons/components/widget-icon';

var ScrollTop = function (_Component) {
  _inherits(ScrollTop, _Component);

  function ScrollTop() {
    var _temp, _this, _ret;

    _classCallCheck(this, ScrollTop);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      visibile: false
    }, _this.handleClick = function () {
      var rootWindow = _this.props.rootWindow;

      var position = rootWindow.pageYOffset;
      // console.log("position", position);
      rootWindow && rootWindow.scrollTo({ top: 0, left: 0, behavior: 'smooth' });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  ScrollTop.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var _props = this.props,
        rootWindow = _props.rootWindow,
        rootDocument = _props.rootDocument;


    if (rootWindow) {
      var updateIconStatus = function updateIconStatus() {
        var scrollHeight = _get(rootWindow, 'pageYOffset');
        var screenHeight = _get(rootWindow, 'screen.height') || _get(rootDocument, 'body.clientHeight');
        if (scrollHeight - screenHeight > 0) {
          _this2.setState({
            visibile: true
          });
        } else {
          _this2.setState({
            visibile: false
          });
        }
      };

      rootWindow.onscroll = function () {
        updateIconStatus();
      };

      if (rootWindow && rootDocument) {
        updateIconStatus();
      }
    }
  };

  ScrollTop.prototype.render = function render() {
    var _props2 = this.props,
        iframeStyles = _props2.iframeStyles,
        position = _props2.position,
        setting = _props2.setting,
        svgSize = _props2.svgSize;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor,
        isAlwayShowScrollTop = setting.isAlwayShowScrollTop;

    var iconSize = _get(setting, 'iconSize');

    return isAlwayShowScrollTop || this.state.visibile ? React.createElement(
      Frame,
      {
        initialContent: '<!DOCTYPE html><html><head>' + iframeStyles + '</head><body></body></html>',
        mountTarget: 'body',
        style: {
          width: iconSize,
          height: iconSize,
          position: 'absolute',
          bottom: position.bottom + 'px',
          right: position.right + 'px',
          transition: 'opacity 0.8s',
          zIndex: '9999997',
          maxWidth: iconSize,
          minWidth: iconSize,
          minHeight: iconSize,
          maxHeight: iconSize
        },
        allowtransparency: 'yes',
        frameBorder: '0'
      },
      React.createElement(WidgetIcon, {
        iconBackgroundColor: iconBackgroundColor,
        iconSize: iconSize,
        iconSrc: scrollIcon,
        iconTextColor: iconTextColor,
        svgSize: 20,
        onClick: this.handleClick
      })
    ) : React.createElement('div', { style: { display: 'none' } });
  };

  return ScrollTop;
}(Component);

export { ScrollTop as default };