import _extends from "babel-runtime/helpers/extends";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _possibleConstructorReturn from "babel-runtime/helpers/possibleConstructorReturn";
import _inherits from "babel-runtime/helpers/inherits";
import _get from "lodash/get";
import React, { Component } from "react";
import Frame from "react-frame-component";
import smsIcon from "../icon/sms.svg";

import WidgetIcon from "../../commons/components/widget-icon";
import Tooltip from "../tooltip";

var Sms = function (_Component) {
  _inherits(Sms, _Component);

  function Sms(props) {
    _classCallCheck(this, Sms);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = { isHover: false };
    return _this;
  }

  Sms.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        iframeStyles = _props.iframeStyles,
        position = _props.position,
        setting = _props.setting,
        svgSize = _props.svgSize,
        component = _props.component;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor;

    var iconSize = _get(setting, "iconSize");
    var link = _get(component, "configurationData.link");
    return React.createElement(
      "div",
      null,
      React.createElement(
        Frame,
        {
          initialContent: "<!DOCTYPE html><html><head>" + iframeStyles + "</head><body></body></html>",
          mountTarget: "body",
          style: {
            width: iconSize,
            height: iconSize,
            position: "absolute",
            bottom: position.bottom + "px",
            right: position.right + "px",
            transition: "opacity 0.8s",
            zIndex: "9999997",
            maxWidth: iconSize,
            minWidth: iconSize,
            minHeight: iconSize,
            maxHeight: iconSize
          },
          allowtransparency: "yes",
          frameBorder: "0"
        },
        React.createElement(
          "a",
          { href: "sms:" + link },
          React.createElement(WidgetIcon, {
            iconBackgroundColor: iconBackgroundColor,
            iconSize: iconSize,
            iconSrc: smsIcon,
            iconTextColor: iconTextColor,
            svgSize: svgSize,
            handleHover: function handleHover(e) {
              return _this2.setState(e);
            }
          })
        )
      ),
      this.state.isHover && React.createElement(Tooltip, _extends({}, this.props, this.state))
    );
  };

  return Sms;
}(Component);

export { Sms as default };