import _extends from 'babel-runtime/helpers/extends';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _get from 'lodash/get';
import React, { Component, useState, useRef, useEffect } from "react";

var Tooltip = function (_Component) {
  _inherits(Tooltip, _Component);

  function Tooltip(props) {
    _classCallCheck(this, Tooltip);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.myRef = React.createRef();
    _this.state = {
      widthText: 0
    };
    return _this;
  }

  Tooltip.prototype.componentDidMount = function componentDidMount() {
    this.getWidthTooltip();
  };

  Tooltip.prototype.componentDidUpdate = function componentDidUpdate() {
    this.getWidthTooltip();
  };

  Tooltip.prototype.getWidthTooltip = function getWidthTooltip() {
    if (this.myRef.current && +this.myRef.current.offsetWidth !== +this.state.widthText && (+this.myRef.current.offsetWidth > +this.state.widthText + 5 || +this.myRef.current.offsetWidth < +this.state.widthText - 5)) {
      this.setState({ widthText: +this.myRef.current.offsetWidth });
    }
  };

  Tooltip.prototype.render = function render() {
    var _props = this.props,
        type = _props.type,
        isSettingLeftBottom = _props.isSettingLeftBottom,
        position = _props.position,
        marginBottom = _props.marginBottom,
        setting = _props.setting,
        isHover = _props.isHover,
        isSettingVertical = _props.isSettingVertical,
        marginRight = _props.marginRight,
        index = _props.index;
    var widthText = this.state.widthText;

    var iconSize = _get(setting, 'iconSize');
    var toolTipHeight = iconSize === 70 ? 44 : iconSize === 60 ? 38 : 36;
    var bottom = isSettingVertical ? (iconSize - toolTipHeight) / 2 + marginBottom + (iconSize + 10) * index : marginBottom + iconSize + 10;
    var positionTextAction = isSettingLeftBottom ? { right: isSettingVertical ? position.right - 10 - widthText : position.right - (widthText - iconSize) / 2 } : { right: isSettingVertical ? marginRight + iconSize + 10 : position.right - (widthText - iconSize) / 2 };
    var style = _extends({
      padding: iconSize === 70 ? '11px 16px' : iconSize === 60 ? '8px 14px' : '7px 12px',
      boxShadow: '0 0 10px 0 rgba(0, 0, 0, 0.16)',
      backgroundColor: '#ffffff',
      position: 'absolute',
      bottom: bottom + 'px',
      fontFamily: 'OpenSans-Regular',
      fontSize: '16px',
      fontWeight: 'normal',
      fontStretch: 'normal',
      fontStyle: 'normal',
      letterSpacing: 'normal',
      textAlign: 'left',
      color: '#000000',
      minWidth: 'max-content'
    }, positionTextAction);
    return React.createElement(
      'span',
      { style: style, ref: this.myRef, className: 'tooltip' },
      type.charAt(0).toUpperCase() + type.slice(1)
    );
  };

  return Tooltip;
}(Component);

export { Tooltip as default };