import _regeneratorRuntime from 'babel-runtime/regenerator';
import _asyncToGenerator from 'babel-runtime/helpers/asyncToGenerator';
import _isEmpty from 'lodash/isEmpty';
import * as actions from './action-type';
import { createAction } from 'redux-actions';


function getDeviceList(cb) {
  // console.log("getDeviceList");
  try {
    var gotDevices = function gotDevices(devices) {
      // console.log("gotDevices: ", JSON.stringify(devices));
      cb(devices || []);
    };

    var handleError = function handleError(error) {
      // console.log("gotDevices-handleError: ", error);
      cb([]);
    };

    navigator.mediaDevices.enumerateDevices().then(gotDevices).catch(handleError);
  } catch (ex) {
    cb([]);
  }
}

export var checkMediaDeviceRequest = createAction(actions.CHECK_MEDIA_DEVICE + '.REQUEST');

export var checkMediaDeviceSuccess = createAction(actions.CHECK_MEDIA_DEVICE + '.SUCCESS');

export var checkMediaDevice = function checkMediaDevice() {
  // console.log("checkMediaDevice");
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(dispatch, store) {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return dispatch(checkMediaDeviceRequest());

            case 2:
              getDeviceList(function (devices) {
                var totalAudioInput = 0;
                var totalAudioOutput = 0;
                var isAllowAcessMedia = false;
                for (var _iterator = devices, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
                  var _ref2;

                  if (_isArray) {
                    if (_i >= _iterator.length) break;
                    _ref2 = _iterator[_i++];
                  } else {
                    _i = _iterator.next();
                    if (_i.done) break;
                    _ref2 = _i.value;
                  }

                  var device = _ref2;

                  var _ref3 = device || {},
                      kind = _ref3.kind,
                      label = _ref3.label;

                  if (kind === 'audioinput') {
                    totalAudioInput++;
                  }

                  if (kind === 'audiooutput') {
                    totalAudioOutput++;
                  }

                  if (!isAllowAcessMedia && !_isEmpty(label)) {
                    isAllowAcessMedia = true;
                  }
                }

                dispatch(checkMediaDeviceSuccess({
                  totalAudioInput: totalAudioInput,
                  totalAudioOutput: totalAudioOutput,
                  devices: devices,
                  isAllowAcessMedia: isAllowAcessMedia
                }));
              });

            case 3:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};