'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var placeholder = _ref.placeholder,
      type = _ref.type,
      isRequired = _ref.isRequired,
      textColor = _ref.textColor,
      backgroundColor = _ref.backgroundColor,
      icon = _ref.icon,
      onChange = _ref.onChange,
      isValid = _ref.isValid,
      inputValue = _ref.inputValue;

  var validField = isValid & isRequired || isRequired & inputValue === '';
  return _react2.default.createElement(
    'div',
    { className: _styles2.default.inputWrapper, style: { backgroundColor: 'transparent', color: textColor } },
    _react2.default.createElement(
      'span',
      { className: _styles2.default.label },
      placeholder
    ),
    _react2.default.createElement('div', { className: _styles2.default.inputBackground, style: { background: textColor } }),
    _react2.default.createElement('input', {
      spellCheck: 'false',
      style: {
        backgroundColor: 'transparent',
        color: textColor,
        border: '' + (validField ? '1px solid red' : 'none')
      },
      onChange: onChange
    }),
    _react2.default.createElement(
      'div',
      { className: _styles2.default.icon },
      icon
    )
  );
};

module.exports = exports['default'];