'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _reactInlinesvg = require('react-inlinesvg');

var _reactInlinesvg2 = _interopRequireDefault(_reactInlinesvg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var iconBackgroundColor = _ref.iconBackgroundColor,
      iconSize = _ref.iconSize,
      iconSrc = _ref.iconSrc,
      iconTextColor = _ref.iconTextColor,
      svgSize = _ref.svgSize,
      onClick = _ref.onClick,
      numberOfNewMessages = _ref.numberOfNewMessages,
      handleHover = _ref.handleHover;

  var isShowBadge = numberOfNewMessages && numberOfNewMessages !== 0;
  return _react2.default.createElement(
    'div',
    {
      className: _styles2.default.minimumIcon,
      style: {
        color: '' + iconBackgroundColor,
        width: iconSize,
        height: iconSize
      },
      onClick: onClick && onClick,
      onMouseEnter: function onMouseEnter() {
        return handleHover && handleHover({ isHover: true });
      },
      onMouseLeave: function onMouseLeave() {
        return handleHover && handleHover({ isHover: false });
      }
    },
    _react2.default.createElement(
      'div',
      { className: _styles2.default.icon },
      _react2.default.createElement(_reactInlinesvg2.default, {
        src: iconSrc,
        style: {
          color: '' + iconTextColor,
          width: svgSize
        }
      })
    ),
    _react2.default.createElement(
      'div',
      { style: { display: isShowBadge ? 'flex' : 'none', width: iconSize / 3, height: iconSize / 3 }, className: _styles2.default.badge },
      numberOfNewMessages
    )
  );
};

module.exports = exports['default'];