'use strict';

exports.__esModule = true;
exports.handleCorrectMessages = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _includes2 = require('lodash/includes');

var _includes3 = _interopRequireDefault(_includes2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _size2 = require('lodash/size');

var _size3 = _interopRequireDefault(_size2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _messageType = require('../constants/message-type');

var _senderTypes = require('../constants/sender-types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultIdForSubscriber = 'subscriber';
var defaultIdForBot = 'bot';
var listTypeMessageHide = [_messageType.MESSAGE_TYPES.QUICK_REPLY, _messageType.MESSAGE_TYPES.DELAY];

var handleCorrectMessages = exports.handleCorrectMessages = function handleCorrectMessages(messages) {
  if ((0, _isEmpty3.default)(messages)) return [];
  var lastPosition = (0, _size3.default)(messages) - 1;
  messages = (messages || []).map(function (message, index) {
    //correct senderId
    // let senderId = get(message, 'senderId') ? get(message, 'senderId') : get(message, 'senderType') === 1 ? defaultIdForSubscriber : defaultIdForBot;

    var senderType = (0, _get3.default)(message, 'senderType');
    // if (!senderType) {
    //   console.log('senderType in: ', JSON.stringify(message));
    // }
    var senderId = senderType === _senderTypes.SENDER_TYPES.ADMIN || senderType === _senderTypes.SENDER_TYPES.BOT ? defaultIdForBot : senderType === _senderTypes.SENDER_TYPES.SUBSCRIBER ? defaultIdForSubscriber : (0, _get3.default)(message, 'senderId') ? (0, _get3.default)(message, 'senderId') : defaultIdForSubscriber;
    // console.log(`senderType: ${senderType} - senderId: ${senderId}`);

    //QuickReply, Typing only show when they are at last message. They will be hidden if there are new coming messages or user select the button on quickReply
    if ((0, _includes3.default)(listTypeMessageHide, (0, _get3.default)(message, 'message.type')) && index !== lastPosition) {
      return (0, _extends3.default)({}, message, {
        isHideMessage: true,
        senderId: senderId
      });
    }
    return (0, _extends3.default)({}, message, {
      senderId: senderId
    });
  });
  return messages;
};