'use strict';

exports.__esModule = true;

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _icon = require('../../../icon');

var _conversationSetting = require('../conversation-setting');

var _conversationSetting2 = _interopRequireDefault(_conversationSetting);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var setting = _ref.setting,
      isInConfigurationMode = _ref.isInConfigurationMode,
      demoData = _ref.demoData,
      currentScreen = _ref.currentScreen,
      isMobileMode = _ref.isMobileMode;

  var showedScreen = isInConfigurationMode ? demoData.currentScreen : currentScreen;

  var activeTheme = (0, _get3.default)(setting, 'activeTheme');
  var iconTextColor = (0, _get3.default)(setting, 'iconTextColor');

  return showedScreen === 'form' ? _react2.default.createElement(
    'div',
    {
      className: _styles2.default.headerContainer + ' ' + _styles2.default.screenForm,
      style: {
        background: (0, _get3.default)(setting, 'iconBackgroundColor'),
        color: iconTextColor,
        borderRadius: '' + (isMobileMode && '0')
      }
    },
    _react2.default.createElement(
      'div',
      { className: _styles2.default.headerRow },
      _react2.default.createElement(
        'span',
        {
          style: {
            color: iconTextColor
          }
        },
        (0, _get3.default)(setting, 'chatboxThemeSettings.' + activeTheme + '.screenForm.header_text_1')
      )
    ),
    _react2.default.createElement(_icon.CloseIcon, { className: _styles2.default.closeIcon, iconTextColor: iconTextColor })
  ) : _react2.default.createElement(
    'div',
    {
      className: _styles2.default.headerContainer + ' ' + _styles2.default.screenConversation,
      style: {
        background: (0, _get3.default)(setting, 'iconBackgroundColor'),
        color: 'white',
        height: 'auto',
        padding: '0px',
        display: 'flex',
        flexDirection: 'row',
        borderRadius: '' + (isMobileMode && '0')
      }
    },
    _react2.default.createElement(
      'div',
      {
        style: {
          flexGrow: 1,
          display: 'flex',
          flexDirection: 'column',
          justifyContent: 'center',
          padding: '24px',
          background: (0, _get3.default)(setting, 'iconBackgroundColor')
        }
      },
      _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'span',
          {
            style: {
              color: iconTextColor
            }
          },
          (0, _get3.default)(setting, 'chatboxThemeSettings.style-three.screenConversation.header_text_1')
        )
      )
    ),
    _react2.default.createElement(
      'div',
      {
        style: {
          width: '40px',
          height: '100%',
          flexGrow: '0',
          background: (0, _get3.default)(setting, 'iconBackgroundColor')
        }
      },
      _react2.default.createElement(_conversationSetting2.default, { setting: setting }),
      _react2.default.createElement(_icon.CloseIcon, { className: _styles2.default.closeIcon, iconTextColor: iconTextColor })
    )
  );
};

module.exports = exports['default'];