'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _find2 = require('lodash/find');

var _find3 = _interopRequireDefault(_find2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _reactFrameComponent = require('react-frame-component');

var _reactFrameComponent2 = _interopRequireDefault(_reactFrameComponent);

var _message = require('../../store/actions/message.actions');

var _widgetContext = require('../../widget-context');

var _widgetContext2 = _interopRequireDefault(_widgetContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LayoutStyleOne = (0, _react.lazy)(function () {
  return import('./layout/style-one');
});
var LayoutStyleTwo = (0, _react.lazy)(function () {
  return import('./layout/style-two');
});
var LayoutStyleThree = (0, _react.lazy)(function () {
  return import('./layout/style-three');
});
var NoConection = (0, _react.lazy)(function () {
  return import('./no-connection');
});

exports.default = function (props) {
  var iframeStyles = props.iframeStyles,
      isInConfigurationMode = props.isInConfigurationMode,
      demoData = props.demoData,
      setting = props.setting,
      isMobileMode = props.isMobileMode,
      area = props.area,
      rect = props.rect,
      isSimulator = props.isSimulator,
      position = props.position,
      isShowChat = props.isShowChat,
      isSettingCollapse = props.isSettingCollapse,
      isSettingLeftBottom = props.isSettingLeftBottom,
      isSettingVertical = props.isSettingVertical,
      marginBottom = props.marginBottom,
      marginRight = props.marginRight,
      marginLeft = props.marginLeft;

  var _useContext = (0, _react.useContext)(_widgetContext2.default),
      online = _useContext.online;

  var dispatch = (0, _reactRedux.useDispatch)();
  var iframeRef = (0, _react.useRef)();
  var activeTheme = setting.activeTheme,
      isEnableAutomation = setting.isEnableAutomation,
      isInOperatingHours = setting.isInOperatingHours;

  var isStartConversationFromAdmin = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get3.default)(store, 'behavior.isStartConversationFromAdmin');
  });
  var alreadySubmitUserInfo = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get3.default)(store, 'behavior.alreadySubmitUserInfo');
  });
  var alreadyStartConversation = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get3.default)(store, 'behavior.alreadyStartConversation');
  });
  var hasTriggeredWelcomeMessage = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get3.default)(store, 'behavior.hasTriggeredWelcomeMessage');
  });
  var lastTimeAcceptChattingWithBot = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get3.default)(store, 'behavior.lastTimeAcceptChattingWithBot');
  });
  var lastTimeAcceptLeavingOfflineMessage = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get3.default)(store, 'behavior.lastTimeAcceptLeavingOfflineMessage');
  });
  var lastTimeReceivingMessageFromAdmin = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get3.default)(store, 'behavior.lastTimeReceivingMessageFromAdmin');
  });

  var messages = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get3.default)(store, 'messages.messages');
  });
  var participants = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get3.default)(store, 'messages.participants');
  });
  var showChat = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get3.default)(store, 'behavior.showChat');
  });

  var getFrameStyle = function getFrameStyle() {
    var isLeftSite = (0, _get3.default)(setting, 'chatboxComponent.position') === 'left-bottom';
    if (isMobileMode) {
      return {
        right: 0,
        bottom: 0,
        position: 'fixed',
        width: '100%',
        minHeight: '250px',
        maxHeight: '100%',
        maxWidth: 'unset',
        // boxShadow: isShowChat ? 'rgba(0, 0, 0, 0.16) 0px 5px 40px' : 'none', // Phần content load sau gây cảm giác chậm
        opacity: isSimulator ? '1' : isShowChat ? '1' : '0',
        transform: isSimulator ? 'scale(1, 1)' : isShowChat ? 'scale(1, 1)' : 'scale(0, 0)',
        transition: 'transform 0.3s ease-in-out,opacity 0.3s ease-in-out , box-shadow 0.3s ease-in-out',
        height: '100%',
        zIndex: 9999998,
        transformOrigin: 'bottom right'
      };
    } else {
      var windowWidth = rect.width;
      var iconSize = setting.iconSize,
          iconMargin = setting.iconMargin;

      var bottom = 10;
      var right = void 0;
      var width = 380;

      if (isSettingCollapse) {
        if (isSettingLeftBottom) {
          if (isSettingVertical) {
            bottom = marginBottom;
            right = position.right - width - iconMargin;
          } else {
            bottom = marginBottom + 10 + iconSize;
            right = windowWidth - width - marginLeft;
          }
        } else {
          if (isSettingVertical) {
            right = (position.right || 10) + iconSize + iconMargin;
            bottom = marginBottom;
          } else {
            bottom = marginBottom + iconSize + 10;
            right = marginRight;
          }
        }
      } else {
        if (isSettingLeftBottom) {
          if (isSettingVertical) {
            bottom = marginBottom;
            right = position.right - width - iconMargin;
          } else {
            bottom = marginBottom + iconSize + iconMargin;
            right = windowWidth - width - marginLeft;
          }
        } else {
          if (isSettingVertical) {
            bottom = marginBottom;
            right = position.right + iconSize + 10;
          } else {
            bottom = marginBottom + 10 + iconSize;
            right = marginRight;
          }
        }
      }

      return {
        right: right + 'px',
        bottom: bottom + 'px',
        position: 'absolute',
        width: width + 'px',
        minHeight: '250px',
        maxHeight: '600px',
        maxWidth: 'unset',
        // boxShadow: isShowChat ? 'rgba(0, 0, 0, 0.16) 0px 5px 40px' : 'none',
        opacity: isSimulator ? '1' : isShowChat ? '1' : '0',
        height: '600px',
        zIndex: 9999998,
        background: 'transparent',
        transform: isSimulator ? 'scale(1, 1)' : isShowChat ? 'scale(1, 1)' : 'scale(0, 0)',
        transition: 'transform 0.3s ease-in-out,opacity 0.3s ease-in-out , box-shadow 0.3s ease-in-out',
        transformOrigin: isSettingLeftBottom ? 'bottom left' : 'bottom right'
      };
    }
  };

  (0, _react.useEffect)(function () {
    if (showChat && !isInConfigurationMode && !isSimulator) {
      dispatch((0, _message.getMessages)(false, setting.channelId));
    }
  }, [showChat]);

  (0, _react.useEffect)(function () {
    // console.log('iframeStyles change!');
    if (iframeRef.current) {
      var stylesheetNode = (0, _find3.default)(iframeRef.current.node.contentDocument.styleSheets, function (node) {
        return (0, _get3.default)(node, 'ownerNode.className') === 'iframe-boostcrm';
      });

      if (stylesheetNode && stylesheetNode.ownerNode) {
        stylesheetNode.ownerNode.outerHTML = iframeStyles;
      }
    }
  }, [iframeStyles]);

  if (!isInConfigurationMode && !online) {
    console.log('!isInConfigurationMode && !online: ', !isInConfigurationMode && !online);
    console.log('isInConfigurationMode: ', isInConfigurationMode);
    console.log('online: ', online);
  }

  return _react2.default.createElement(
    _reactFrameComponent2.default,
    {
      ref: iframeRef,
      initialContent: '<!DOCTYPE html><html><head>          \n        <link href="https://fonts.googleapis.com/css?family=Comfortaa&display=swap" rel="stylesheet">\n        <link href="https://fonts.googleapis.com/css?family=Roboto&display=swap" rel="stylesheet">\n        <link href="https://fonts.googleapis.com/css2?family=Open+Sans&display=swap" rel="stylesheet">\n        <style>\n          .bs-chatbox-input-container .ant-upload {\n            display: flex !important;\n          }\n          .bs-chat-box-form .ant-form-item-control {\n            line-height: 31px !important;\n          }\n        </style>\n        ' + iframeStyles + '</head><body></body></html>\n      ',
      mountTarget: 'body',
      allowtransparency: 'yes',
      style: getFrameStyle(),
      frameBorder: '0',
      id: 'bs-chatbox'
    },
    !isInConfigurationMode && !online ? _react2.default.createElement(NoConection, (0, _extends3.default)({}, props, { isInConfigurationMode: isInConfigurationMode, demoData: demoData, isMobileMode: isMobileMode })) : _react2.default.createElement(
      'div',
      { style: { width: '100%', height: '100%' } },
      activeTheme === 'style-one' && _react2.default.createElement(
        _react.Suspense,
        { fallback: _react2.default.createElement('div', null) },
        _react2.default.createElement(LayoutStyleOne, (0, _extends3.default)({}, props, {
          lastTimeAcceptChattingWithBot: lastTimeAcceptChattingWithBot,
          lastTimeAcceptLeavingOfflineMessage: lastTimeAcceptLeavingOfflineMessage,
          lastTimeReceivingMessageFromAdmin: lastTimeReceivingMessageFromAdmin,
          isStartConversationFromAdmin: isStartConversationFromAdmin,
          alreadySubmitUserInfo: alreadySubmitUserInfo,
          messages: messages,
          participants: participants,
          isInConfigurationMode: isInConfigurationMode,
          demoData: demoData,
          isEnableAutomation: isEnableAutomation,
          isInOperatingHours: isInOperatingHours
        }))
      ),
      activeTheme === 'style-two' && _react2.default.createElement(
        _react.Suspense,
        { fallback: _react2.default.createElement('div', null) },
        _react2.default.createElement(LayoutStyleTwo, (0, _extends3.default)({}, props, {
          lastTimeAcceptChattingWithBot: lastTimeAcceptChattingWithBot,
          lastTimeAcceptLeavingOfflineMessage: lastTimeAcceptLeavingOfflineMessage,
          lastTimeReceivingMessageFromAdmin: lastTimeReceivingMessageFromAdmin,
          isStartConversationFromAdmin: isStartConversationFromAdmin,
          alreadySubmitUserInfo: alreadySubmitUserInfo,
          alreadyStartConversation: alreadyStartConversation,
          messages: messages,
          participants: participants,
          isInConfigurationMode: isInConfigurationMode,
          demoData: demoData,
          isEnableAutomation: isEnableAutomation,
          isInOperatingHours: isInOperatingHours
        }))
      ),
      activeTheme === 'style-three' && _react2.default.createElement(
        _react.Suspense,
        { fallback: _react2.default.createElement('div', null) },
        _react2.default.createElement(LayoutStyleThree, (0, _extends3.default)({}, props, {
          lastTimeAcceptChattingWithBot: lastTimeAcceptChattingWithBot,
          lastTimeAcceptLeavingOfflineMessage: lastTimeAcceptLeavingOfflineMessage,
          lastTimeReceivingMessageFromAdmin: lastTimeReceivingMessageFromAdmin,
          isStartConversationFromAdmin: isStartConversationFromAdmin,
          alreadySubmitUserInfo: alreadySubmitUserInfo,
          alreadyStartConversation: alreadyStartConversation,
          hasTriggeredWelcomeMessage: hasTriggeredWelcomeMessage,
          messages: messages,
          participants: participants,
          isInConfigurationMode: isInConfigurationMode,
          demoData: demoData,
          isEnableAutomation: isEnableAutomation,
          isInOperatingHours: isInOperatingHours
        }))
      )
    )
  );
};

module.exports = exports['default'];