"use strict";

exports.__esModule = true;

var _get2 = require("lodash/get");

var _get3 = _interopRequireDefault(_get2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _styles = require("./styles.scss");

var _styles2 = _interopRequireDefault(_styles);

var _close = require("../../../../icon/close.svg");

var _close2 = _interopRequireDefault(_close);

var _file_general = require("../../../../icon/file_general.svg");

var _file_general2 = _interopRequireDefault(_file_general);

var _reactInlinesvg = require("react-inlinesvg");

var _reactInlinesvg2 = _interopRequireDefault(_reactInlinesvg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var setting = _ref.setting,
      attachment = _ref.attachment,
      handleClickRemove = _ref.handleClickRemove;

  // console.log(attachment);
  var _ref2 = attachment || {},
      src = _ref2.src,
      type = _ref2.type,
      isImage = _ref2.isImage,
      base64 = _ref2.base64,
      name = _ref2.name;

  return _react2.default.createElement(
    "div",
    {
      className: _styles2.default.container,
      style: {
        width: !isImage ? "110px" : "55px",
        padding: !isImage ? "7px 10px 7px 10px" : "0px"
      }
    },
    isImage && base64 && _react2.default.createElement("img", { className: _styles2.default.imageAttachment, src: base64 }),
    !isImage && name && _react2.default.createElement(
      "div",
      { className: _styles2.default.fileAttachmentWrapper },
      _react2.default.createElement(
        "div",
        { className: _styles2.default.fileAttachmentIcon },
        _react2.default.createElement(_reactInlinesvg2.default, { src: _file_general2.default, style: { width: "32.7px", height: "40.5px" } })
      ),
      _react2.default.createElement(
        "div",
        { className: _styles2.default.fileName },
        name
      )
    ),
    _react2.default.createElement(
      "span",
      {
        className: _styles2.default.iconClose,
        onClick: handleClickRemove,
        style: {
          backgroundColor: (0, _get3.default)(setting, "screenConversation.rightSideBackgroundColor"),
          color: (0, _get3.default)(setting, "screenConversation.rightSideTextColor")
        }
      },
      _react2.default.createElement(_reactInlinesvg2.default, { src: _close2.default, style: { width: "7px", height: "7px" } })
    )
  );
};

module.exports = exports["default"];