'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _size2 = require('lodash/size');

var _size3 = _interopRequireDefault(_size2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _message = require('../../../store/actions/message.actions');

var _styleOne = require('./style-one');

var _styleOne2 = _interopRequireDefault(_styleOne);

var _styleTwo = require('./style-two');

var _styleTwo2 = _interopRequireDefault(_styleTwo);

var _styleThree = require('./style-three');

var _styleThree2 = _interopRequireDefault(_styleThree);

var _checkValidFile = require('./utils/check-valid-file');

var _checkValidFile2 = _interopRequireDefault(_checkValidFile);

var _isImageFile = require('./utils/is-image-file');

var _isImageFile2 = _interopRequireDefault(_isImageFile);

var _getBase = require('./utils/get-base64');

var _getBase2 = _interopRequireDefault(_getBase);

var _getFileMetaData = require('./utils/get-file-meta-data');

var _getFileMetaData2 = _interopRequireDefault(_getFileMetaData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MAX_COUNT_FILE = 3;

var BSChatBoxInput = function (_Component) {
  (0, _inherits3.default)(BSChatBoxInput, _Component);

  function BSChatBoxInput() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, BSChatBoxInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      inputValue: '',
      uploadFiles: []
    }, _this.checkInputValueAndSend = function () {
      var _this$state = _this.state,
          inputValue = _this$state.inputValue,
          uploadFiles = _this$state.uploadFiles;
      var setting = _this.props.setting;

      var trimValue = (inputValue || '').trim();
      if ((0, _isEmpty3.default)(trimValue) && (0, _isEmpty3.default)(uploadFiles)) return;

      if (!(0, _isEmpty3.default)(uploadFiles)) {
        _this.props.actions.sendAttachment(inputValue.trim(), uploadFiles, setting.channelId);
        _this.setState({
          inputValue: '',
          uploadFiles: []
        });
        return;
      }

      if (!(0, _isEmpty3.default)(inputValue)) {
        _this.props.actions.sendTextMessage(inputValue.trim(), setting.channelId);
        _this.setState({
          inputValue: ''
        });
        return;
      }
    }, _this.handleKeyPress = function (event) {
      // console.log(`handleKeyPress ${event.key} - ${event.shiftKey}`);
      if (event.key === 'Enter' && !event.shiftKey) {
        _this.checkInputValueAndSend();
        event.preventDefault();
      }
    }, _this.handleOnChange = function (event) {
      _this.setState({
        inputValue: event.target.value
      });
    }, _this.handleClickBtnSend = function () {
      _this.checkInputValueAndSend();
    }, _this.handleBeforeUploadAttachments = function (file) {
      var uploadFiles = _this.state.uploadFiles;
      // console.log("file", file);

      if (!(0, _checkValidFile2.default)(file) || (0, _size3.default)(uploadFiles) >= MAX_COUNT_FILE) {
        window && window.alert('Max 3 files, max size 1MB');
        return false;
      }

      var isImage = (0, _isImageFile2.default)(file);
      var newAttachment = (0, _extends3.default)({
        originalFile: file
      }, (0, _getFileMetaData2.default)(file), {
        isImage: isImage
      });

      isImage ? (0, _getBase2.default)(file, function (base64) {
        _this.setState({
          uploadFiles: [].concat(uploadFiles, [(0, _extends3.default)({}, newAttachment, {
            base64: base64
          })])
        });
      }) : _this.setState({
        uploadFiles: [].concat(uploadFiles, [newAttachment])
      });

      return false;
    }, _this.handleRemoveAttachment = function (attachment) {
      _this.setState({
        uploadFiles: _this.state.uploadFiles.filter(function (obj) {
          return obj !== attachment;
        })
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  BSChatBoxInput.prototype.render = function render() {
    var callbacks = {
      handleKeyPress: this.handleKeyPress.bind(this),
      handleOnChange: this.handleOnChange.bind(this),
      handleClickBtnSend: this.handleClickBtnSend.bind(this),
      handleRemoveAttachment: this.handleRemoveAttachment.bind(this),
      handleBeforeUploadAttachments: this.handleBeforeUploadAttachments.bind(this)
    };
    var setting = this.props.setting;

    var activeTheme = (0, _get3.default)(setting, 'activeTheme');
    // console.log("checkporps", this.props);
    return _react2.default.createElement(
      'div',
      { style: { height: '80px', flexGrow: '0' } },
      activeTheme === 'style-two' && _react2.default.createElement(_styleTwo2.default, (0, _extends3.default)({}, this.props, {
        attachments: this.state.attachments
      }, callbacks, {
        uploadFiles: this.state.uploadFiles,
        inputValue: this.state.inputValue
      })),
      activeTheme === 'style-one' && _react2.default.createElement(_styleOne2.default, (0, _extends3.default)({}, this.props, {
        attachments: this.state.attachments
      }, callbacks, {
        uploadFiles: this.state.uploadFiles,
        inputValue: this.state.inputValue
      })),
      activeTheme === 'style-three' && _react2.default.createElement(_styleThree2.default, (0, _extends3.default)({}, this.props, {
        attachments: this.state.attachments
      }, callbacks, {
        uploadFiles: this.state.uploadFiles,
        inputValue: this.state.inputValue
      }))
    );
  };

  return BSChatBoxInput;
}(_react.Component);

exports.default = (0, _reactRedux.connect)(function (store) {
  return {};
}, function (dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)({
      sendTextMessage: _message.sendTextMessage,
      sendAttachment: _message.sendAttachment
    }, dispatch)
  };
})(BSChatBoxInput);
module.exports = exports['default'];