'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _photo = require('../../../icon/photo.svg');

var _photo2 = _interopRequireDefault(_photo);

var _attach = require('../../../icon/attach.svg');

var _attach2 = _interopRequireDefault(_attach);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _reactInlinesvg = require('react-inlinesvg');

var _reactInlinesvg2 = _interopRequireDefault(_reactInlinesvg);

var _attachmentList = require('../components/attachment-list');

var _attachmentList2 = _interopRequireDefault(_attachmentList);

var _rcUpload = require('rc-upload');

var _rcUpload2 = _interopRequireDefault(_rcUpload);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StyleOne = function (_Component) {
  (0, _inherits3.default)(StyleOne, _Component);

  function StyleOne() {
    (0, _classCallCheck3.default)(this, StyleOne);
    return (0, _possibleConstructorReturn3.default)(this, _Component.apply(this, arguments));
  }

  StyleOne.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        setting = _props.setting,
        uploadFiles = _props.uploadFiles,
        inputValue = _props.inputValue,
        handleRemoveAttachment = _props.handleRemoveAttachment;

    var iconColor = (0, _get3.default)(setting, 'screenForm.placeholderTextColor');

    return _react2.default.createElement(
      'div',
      { className: _styles2.default.inputContainer + ' bs-chatbox-input-container' },
      !(0, _isEmpty3.default)(uploadFiles) && _react2.default.createElement(_attachmentList2.default, { uploadFiles: uploadFiles, setting: setting, handleRemoveAttachment: handleRemoveAttachment }),
      _react2.default.createElement(
        'div',
        { className: _styles2.default.inputRow },
        _react2.default.createElement('textarea', {
          value: inputValue,
          placeholder: (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.send_message_placeholder'),
          onChange: this.props.handleOnChange,
          onKeyPress: function onKeyPress(e) {
            _this2.props.handleKeyPress(e);
          },
          style: {
            color: (0, _isEmpty3.default)(inputValue) ? (0, _get3.default)(setting, 'screenForm.placeholderTextColor') : (0, _get3.default)(setting, 'screenForm.inputTextColor')
          }
        })
      ),
      _react2.default.createElement(
        'div',
        { className: _styles2.default.additionalFunctionRow },
        _react2.default.createElement(
          'div',
          { className: _styles2.default.left },
          _react2.default.createElement(
            'span',
            { className: _styles2.default.icon },
            _react2.default.createElement(
              _rcUpload2.default,
              { showUploadList: false, multiple: true, beforeUpload: this.props.handleBeforeUploadAttachments },
              _react2.default.createElement(_reactInlinesvg2.default, {
                src: _attach2.default,
                style: {
                  width: '16.9px',
                  height: '17.6px',
                  color: iconColor
                }
              })
            )
          ),
          _react2.default.createElement(
            'span',
            { className: _styles2.default.icon },
            _react2.default.createElement(
              _rcUpload2.default,
              { showUploadList: false, multiple: true, beforeUpload: this.props.handleBeforeUploadAttachments },
              _react2.default.createElement(_reactInlinesvg2.default, {
                src: _photo2.default,
                style: {
                  width: '20.5px',
                  height: '17.6px',
                  color: iconColor
                }
              })
            )
          )
        ),
        _react2.default.createElement(
          'div',
          { className: _styles2.default.right },
          _react2.default.createElement(
            'span',
            {
              className: _styles2.default.btnSend,
              onClick: this.props.handleClickBtnSend,
              style: {
                backgroundColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor'),
                color: (0, _get3.default)(setting, 'screenConversation.rightSideTextColor')
              }
            },
            'Send'
          )
        )
      )
    );
  };

  return StyleOne;
}(_react.Component);

exports.default = StyleOne;
module.exports = exports['default'];