'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _last2 = require('lodash/last');

var _last3 = _interopRequireDefault(_last2);

var _throttle2 = require('lodash/throttle');

var _throttle3 = _interopRequireDefault(_throttle2);

var _delay2 = require('lodash/delay');

var _delay3 = _interopRequireDefault(_delay2);

var _size2 = require('lodash/size');

var _size3 = _interopRequireDefault(_size2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chatMessageContainer = require('chat-message-container');

var _chatMessageContainer2 = _interopRequireDefault(_chatMessageContainer);

var _reactSound = require('react-sound');

var _reactSound2 = _interopRequireDefault(_reactSound);

var _sound = require('../../sounds/sound');

var sound = _interopRequireWildcard(_sound);

var _actions = require('../../../store/actions');

var _reactRedux = require('react-redux');

var _redux = require('redux');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ChatMessageContainer = function (_React$Component) {
  (0, _inherits3.default)(ChatMessageContainer, _React$Component);

  function ChatMessageContainer(props) {
    (0, _classCallCheck3.default)(this, ChatMessageContainer);

    var _this = (0, _possibleConstructorReturn3.default)(this, _React$Component.call(this, props));

    _this.scrollToBottom = function () {
      if (_this.refs.chatMessageContainer) {
        (0, _delay3.default)(function () {
          _this.refs.chatMessageContainer && _this.refs.chatMessageContainer.scrollToBottom();
          (0, _delay3.default)(function () {
            _this.props.actions.onScrollToBottom();
          }, 500);
        }, 100);
      }
    };

    _this.isScrollingOnBottom = function () {
      if (_this.refs.chatMessageContainer) {
        return _this.refs.chatMessageContainer.isAtBottom();
      }
      return false;
    };

    _this.handleSoundStartFinishedPlaying = function (value) {
      _this.setState({ isNewMessage: value });
    };

    _this.loadMoreMessages = function () {
      var _this$props = _this.props,
          isLoadingMessage = _this$props.isLoadingMessage,
          setting = _this$props.setting;

      if (isLoadingMessage) return;
      _this.throttledLoadMessageHistory(setting.channelId);
    };

    _this.isScrollingOnTop = function () {
      if (_this.refs.chatMessageContainer) {
        var _this$refs$chatMessag = _this.refs.chatMessageContainer.scrollbarRef.getValues(),
            top = _this$refs$chatMessag.top;

        if (top === 0) {
          return true;
        }
      }
      return false;
    };

    _this.scrollToPositionBeforeLoadMore = function () {
      var messageContainerHeight = _this.state.messageContainerHeight;

      if (_this.refs.chatMessageContainer) {
        var currentHeight = _this.refs.chatMessageContainer.scrollbarRef.getScrollHeight();
        (0, _delay3.default)(function () {
          var scrollTopValue = currentHeight - messageContainerHeight;
          _this.refs.chatMessageContainer.scrollbarRef.scrollTop(scrollTopValue);
        }, 100);
      }
    };

    _this.updateMessageContainerHeight = function () {
      _this.setState({
        messageContainerHeight: _this.refs.chatMessageContainer.scrollbarRef.getScrollHeight()
      });
    };

    _this.state = {
      isNewMessage: false,
      originalMessage: null
    };
    _this.throttledLoadMessageHistory = (0, _throttle3.default)(function (channelId) {
      _this.props.actions.getMessages(true, channelId);
    }, 500, { trailing: false });
    _this.throttledPlaySound = (0, _throttle3.default)(function (value) {
      _this.handleSoundStartFinishedPlaying(value);
    }, 2000, { trailing: false });
    return _this;
  }

  ChatMessageContainer.prototype.componentDidMount = function componentDidMount() {
    //Scroll to bottom when F5 page
    this.scrollToBottom();
  };

  ChatMessageContainer.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    if (nextProps.messages && nextProps.messages !== prevState.originalMessage) {
      return {
        originalMessage: nextProps.messages
      };
    } else {
      return null;
    }
  };

  ChatMessageContainer.prototype.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    var sender = (0, _get3.default)((0, _last3.default)(this.state.originalMessage), 'senderId');
    if (prevState.originalMessage !== this.state.originalMessage) {
      if ((0, _size3.default)(this.state.originalMessage) - (0, _size3.default)(prevState.originalMessage) === 1) {
        if (sender === 'subscriber') {
          this.scrollToBottom();
        } else {
          //playsoud when receiving new message
          if (this.props.soundOn && this.props.numberOfNewMessages !== 0) {
            this.throttledPlaySound(true);
          }
          //is at bottom
          if (this.isScrollingOnBottom()) {
            this.scrollToBottom();
          }
        }
      }
      //loadmore message
      if ((0, _size3.default)(prevState.originalMessage) !== 0 && (0, _size3.default)(prevState.originalMessage) < (0, _size3.default)(this.state.originalMessage) && this.isScrollingOnTop()) {
        this.scrollToPositionBeforeLoadMore();
      }
      //update scroll height
      this.updateMessageContainerHeight();
    }
  };

  ChatMessageContainer.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        containerBgColor = _props.containerBgColor,
        isShowLeftAvatar = _props.isShowLeftAvatar,
        isShowRightAvatar = _props.isShowRightAvatar,
        isShowSeenTime = _props.isShowSeenTime,
        avatarWidth = _props.avatarWidth,
        avatarMargin = _props.avatarMargin,
        style = _props.style,
        textFontSize = _props.textFontSize,
        messageMargin = _props.messageMargin,
        onClickButton = _props.onClickButton,
        leftParitcipantsTextColor = _props.leftParitcipantsTextColor,
        leftParitcipantsTextBgColor = _props.leftParitcipantsTextBgColor,
        rightParitcipantsTextColor = _props.rightParitcipantsTextColor,
        rightParitcipantsTextBgColor = _props.rightParitcipantsTextBgColor,
        messages = _props.messages,
        participants = _props.participants;
    // console.log("message ", messages);

    return _react2.default.createElement(
      _react2.default.Fragment,
      null,
      this.state.isNewMessage && _react2.default.createElement(_reactSound2.default, {
        url: sound.SOUND_NEW_MESSAGE,
        playStatus: _reactSound2.default.status.PLAYING,
        onFinishedPlaying: function onFinishedPlaying() {
          return _this2.handleSoundStartFinishedPlaying(false);
        }
      }),
      _react2.default.createElement(_chatMessageContainer2.default, {
        containerBgColor: containerBgColor,
        isShowLeftAvatar: isShowLeftAvatar,
        isShowRightAvatar: isShowRightAvatar,
        isShowSeenTime: isShowSeenTime,
        avatarWidth: avatarWidth,
        avatarMargin: avatarMargin,
        style: style,
        textFontSize: textFontSize,
        messageMargin: messageMargin,
        onScrollTop: function onScrollTop() {
          return _this2.loadMoreMessages();
        },
        onScrollBottom: function onScrollBottom() {
          return _this2.scrollToBottom();
        },
        onClickButton: onClickButton,
        leftParitcipantsTextColor: leftParitcipantsTextColor,
        leftParitcipantsTextBgColor: leftParitcipantsTextBgColor,
        rightParitcipantsTextColor: rightParitcipantsTextColor,
        rightParitcipantsTextBgColor: rightParitcipantsTextBgColor,
        messages: messages,
        participants: participants,
        noMessageText: 'No messages',
        isChatbox: true,
        ref: 'chatMessageContainer'
      })
    );
  };

  return ChatMessageContainer;
}(_react2.default.Component);

exports.default = (0, _reactRedux.connect)(function (store) {
  return { numberOfNewMessages: (0, _get3.default)(store, 'messages.numberOfNewMessages') };
}, function (dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)({
      getMessages: _actions.getMessages,
      onScrollToBottom: _actions.onScrollToBottom
    }, dispatch)
  };
})(ChatMessageContainer);
module.exports = exports['default'];