'use strict';

exports.__esModule = true;

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _includes = require('lodash/includes');

var _includes2 = _interopRequireDefault(_includes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _commonStyles = require('../../common-styles.scss');

var _commonStyles2 = _interopRequireDefault(_commonStyles);

var _userInfoForm = require('../../user-info-form');

var _userInfoForm2 = _interopRequireDefault(_userInfoForm);

var _header = require('../../header');

var _header2 = _interopRequireDefault(_header);

var _power = require('../../power');

var _power2 = _interopRequireDefault(_power);

var _input = require('../../input');

var _input2 = _interopRequireDefault(_input);

var _utils = require('../../../../commons/utils');

var _offline = require('../../offline');

var _offline2 = _interopRequireDefault(_offline);

var _reactRedux = require('react-redux');

var _actions = require('../../../../store/actions');

var _messageContainer = require('../message-container');

var _messageContainer2 = _interopRequireDefault(_messageContainer);

var _widgetContext = require('../../../../widget-context');

var _widgetContext2 = _interopRequireDefault(_widgetContext);

var _noConnection = require('../../no-connection');

var _noConnection2 = _interopRequireDefault(_noConnection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (props) {
  var alreadyStartConversation = props.alreadyStartConversation,
      isInConfigurationMode = props.isInConfigurationMode,
      isMobileMode = props.isMobileMode,
      setting = props.setting,
      messages = props.messages,
      participants = props.participants,
      demoData = props.demoData;

  var dispatch = (0, _reactRedux.useDispatch)();

  var _useContext = (0, _react.useContext)(_widgetContext2.default),
      isSimulator = _useContext.isSimulator;

  var showedScreen = isSimulator ? 'conversation' : (0, _utils.getCurrentScreen)(props);
  var soundOn = isSimulator ? false : (0, _reactRedux.useSelector)(function (store) {
    return (0, _get3.default)(store, 'behavior.soundOn');
  });
  var isViewForOffline = showedScreen === 'off' || showedScreen === 'off_with_chatbot';

  return _react2.default.createElement(
    'div',
    {
      className: _commonStyles2.default.conversationContainer,
      style: {
        borderRadius: '' + (isMobileMode ? '0' : '18px')
      }
    },
    isViewForOffline && _react2.default.createElement(_offline2.default, { setting: setting, showedScreen: showedScreen }),
    !isViewForOffline && _react2.default.createElement(
      _react2.default.Fragment,
      null,
      !isSimulator && !(0, _includes2.default)(['off', 'no_connection'], showedScreen) && _react2.default.createElement(_header2.default, {
        setting: setting,
        isInConfigurationMode: isInConfigurationMode,
        demoData: demoData,
        currentScreen: showedScreen,
        isMobileMode: isMobileMode
      }),
      _react2.default.createElement(
        'div',
        { className: _commonStyles2.default.boxBody },
        showedScreen === 'form' && _react2.default.createElement(_userInfoForm2.default, { setting: setting, isInConfigurationMode: isInConfigurationMode }),
        showedScreen === 'conversation' && _react2.default.createElement(
          'div',
          { className: _commonStyles2.default.messageContainer },
          _react2.default.createElement(_messageContainer2.default, {
            containerBgColor: 'white',
            isShowLeftAvatar: false,
            isShowRightAvatar: false,
            isShowSeenTime: false,
            avatarWidth: 25,
            avatarMargin: 0,
            style: 2,
            textFontSize: 12,
            messageMargin: 25,
            onScrollTop: function onScrollTop() {},
            onClickButton: function onClickButton(buttonData) {
              return dispatch((0, _actions.sendButtonMessage)(buttonData, setting.channelId));
            },
            leftParitcipantsTextColor: (0, _get3.default)(setting, 'screenConversation.leftSideTextColor'),
            leftParitcipantsTextBgColor: (0, _get3.default)(setting, 'screenConversation.leftSideBackgroundColor'),
            rightParitcipantsTextColor: (0, _get3.default)(setting, 'screenConversation.rightSideTextColor'),
            rightParitcipantsTextBgColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor'),
            messages: isInConfigurationMode ? demoData.messages : messages,
            participants: isInConfigurationMode ? demoData.participants : participants,
            soundOn: soundOn,
            setting: setting
          })
        ),
        showedScreen === 'conversation' && _react2.default.createElement(_input2.default, { setting: setting, isInConfigurationMode: isInConfigurationMode }),
        showedScreen === 'no_connection' && _react2.default.createElement(_noConnection2.default, { setting: setting, isInConfigurationMode: isInConfigurationMode, demoData: demoData, isMobileMode: isMobileMode })
      )
    ),
    _react2.default.createElement(_power2.default, { setting: setting, showedScreen: showedScreen, isInConfigurationMode: isInConfigurationMode })
  );
};

module.exports = exports['default'];