'use strict';

exports.__esModule = true;

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _header = require('../../header');

var _header2 = _interopRequireDefault(_header);

var _power = require('../../power');

var _power2 = _interopRequireDefault(_power);

var _commonStyles = require('../../common-styles.scss');

var _commonStyles2 = _interopRequireDefault(_commonStyles);

var _no_connection = require('../../../icon/no_connection.svg');

var _no_connection2 = _interopRequireDefault(_no_connection);

var _reactInlinesvg = require('react-inlinesvg');

var _reactInlinesvg2 = _interopRequireDefault(_reactInlinesvg);

var _widgetContext = require('../../../../widget-context');

var _widgetContext2 = _interopRequireDefault(_widgetContext);

var _commonHandlers = require('../common-handlers');

var _reload = require('../../../icon/reload.svg');

var _reload2 = _interopRequireDefault(_reload);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (props) {
  var setting = props.setting,
      isInConfigurationMode = props.isInConfigurationMode,
      demoData = props.demoData,
      showedScreen = props.showedScreen,
      isMobileMode = props.isMobileMode;

  var _useContext = (0, _react.useContext)(_widgetContext2.default),
      isReconnecting = _useContext.isReconnecting,
      isConnectFailed = _useContext.isConnectFailed;

  var isShowReloadContent = !isReconnecting && isConnectFailed || isInConfigurationMode;
  return _react2.default.createElement(
    'div',
    { className: _commonStyles2.default.noConnectionContainer, style: { borderRadius: isMobileMode ? '0' : '18px' } },
    _react2.default.createElement(_header2.default, { setting: setting, isInConfigurationMode: isInConfigurationMode, demoData: demoData, currentScreen: showedScreen }),
    _react2.default.createElement(
      'div',
      { className: _commonStyles2.default.boxBody },
      _react2.default.createElement(_reactInlinesvg2.default, { className: _commonStyles2.default.image, src: _no_connection2.default }),
      isReconnecting && !isConnectFailed && _react2.default.createElement(
        'span',
        { className: _commonStyles2.default.wsStatus },
        'Reconnecting...'
      ),
      isShowReloadContent && _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(
          'span',
          { className: _commonStyles2.default.title },
          (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.no_conect_title')
        ),
        _react2.default.createElement(
          'span',
          { className: _commonStyles2.default.subtitle },
          (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.no_conect_subtitle')
        ),
        _react2.default.createElement(
          'span',
          {
            className: _commonStyles2.default.btnReload,
            onClick: _commonHandlers.clickReloadHandler,
            style: {
              color: (0, _get3.default)(setting, 'screenConversation.rightSideTextColor'),
              backgroundColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor')
            }
          },
          _react2.default.createElement(_reactInlinesvg2.default, { className: _commonStyles2.default.reloadIcon, src: _reload2.default }),
          (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.no_conect_btn_reload_label') || 'Reload'
        )
      )
    ),
    _react2.default.createElement(_power2.default, { setting: setting, showedScreen: showedScreen })
  );
};

module.exports = exports['default'];