'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _offlineStatus = require('./offline-status.scss');

var _offlineStatus2 = _interopRequireDefault(_offlineStatus);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _actions = require('../../../store/actions');

var _icon = require('../../icon');

var _websocket = require('../../../commons/constants/websocket');

var _withoutAutomation = require('./components/without-automation');

var _withoutAutomation2 = _interopRequireDefault(_withoutAutomation);

var _withAutomation = require('./components/with-automation');

var _withAutomation2 = _interopRequireDefault(_withAutomation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OfflineStatus = function (_React$Component) {
  (0, _inherits3.default)(OfflineStatus, _React$Component);

  function OfflineStatus() {
    (0, _classCallCheck3.default)(this, OfflineStatus);

    var _this = (0, _possibleConstructorReturn3.default)(this, _React$Component.call(this));

    _this.onStartConversation = function (message) {};

    _this.state = { message: null };
    return _this;
  }

  OfflineStatus.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        setting = _props.setting,
        showedScreen = _props.showedScreen;

    return _react2.default.createElement(
      'div',
      { className: _offlineStatus2.default.container },
      showedScreen === 'off' && _react2.default.createElement(_withoutAutomation2.default, {
        setting: setting,
        onStartConversation: function onStartConversation(message) {
          var isInConfigurationMode = _this2.props.isInConfigurationMode;

          if (isInConfigurationMode) return;
          _this2.props.actions.startConversation(_websocket.BUTTON_STARTS.LEAVE_MESSAGE, {
            isWorkingDay: setting.isInOperatingHours,
            leaveMessage: message
          });
        }
      }),
      showedScreen === 'off_with_chatbot' && _react2.default.createElement(_withAutomation2.default, {
        setting: setting,
        onStartConversation: function onStartConversation() {
          _this2.props.actions.startConversation(_websocket.BUTTON_STARTS.CHAT_WITH_BOT, {
            isWorkingDay: setting.isInOperatingHours
          });
        }
      }),
      _react2.default.createElement(_icon.CloseIcon, { className: _offlineStatus2.default.closeIcon, iconTextColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor') })
    );
  };

  return OfflineStatus;
}(_react2.default.Component);

exports.default = (0, _reactRedux.connect)(function (store) {
  return {
    userInfo: (0, _get3.default)(store, 'behavior.userInfo')
  };
}, function (dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)({ startConversation: _actions.startConversation }, dispatch)
  };
})(OfflineStatus);
module.exports = exports['default'];