'use strict';

exports.__esModule = true;

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _includes2 = require('lodash/includes');

var _includes3 = _interopRequireDefault(_includes2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _userInfoForm = require('./user-info-form.scss');

var _userInfoForm2 = _interopRequireDefault(_userInfoForm);

var _actions = require('../../../store/actions');

var _formInput = require('../../../commons/components/form-input');

var _formInput2 = _interopRequireDefault(_formInput);

var _formCheckbox = require('../../../commons/components/form-checkbox');

var _formCheckbox2 = _interopRequireDefault(_formCheckbox);

var _btnStartConversation = require('./btn-start-conversation');

var _btnStartConversation2 = _interopRequireDefault(_btnStartConversation);

var _skipForm = require('../../icon/skip-form.svg');

var _skipForm2 = _interopRequireDefault(_skipForm);

var _reactInlinesvg = require('react-inlinesvg');

var _reactInlinesvg2 = _interopRequireDefault(_reactInlinesvg);

var _name = require('../../icon/name.svg');

var _name2 = _interopRequireDefault(_name);

var _email = require('../../icon/email.svg');

var _email2 = _interopRequireDefault(_email);

var _phone = require('../../icon/phone.svg');

var _phone2 = _interopRequireDefault(_phone);

var _reactHookForm = require('react-hook-form');

var _reactRedux = require('react-redux');

var _websocket = require('../../../commons/constants/websocket');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var setting = _ref.setting;

  var _useState = (0, _react.useState)(null),
      name = _useState[0],
      setName = _useState[1];

  var _useState2 = (0, _react.useState)(null),
      email = _useState2[0],
      setEmail = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      phone = _useState3[0],
      setPhone = _useState3[1];

  var _useState4 = (0, _react.useState)(false),
      checkPrivacyPolicyConsent = _useState4[0],
      setCheckPrivacyPolicyConsent = _useState4[1];

  var _useForm = (0, _reactHookForm.useForm)(),
      handleSubmit = _useForm.handleSubmit;

  var _useState5 = (0, _react.useState)(false),
      isSubmit = _useState5[0],
      setSubmit = _useState5[1];

  var dispatch = (0, _reactRedux.useDispatch)();

  var activeTheme = (0, _get3.default)(setting, 'activeTheme');
  var enableFieldName = (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.form_name_enable');
  var enableFieldEmail = (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.form_email_enable');
  var enableFieldPhone = (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.form_phone_enable');
  var enablePrivacyPolicyConsent = (0, _get3.default)(setting, 'chatboxThemeSettings.preChatForm.privacy_consent_enable') === true;

  var privacyPolicyMessage = (0, _get3.default)(setting, 'chatboxThemeSettings.preChatForm.privacy_consent_message');
  var privacyPolicyLink = (0, _get3.default)(setting, 'chatboxThemeSettings.preChatForm.privacy_consent_link');
  var requiredFieldName = (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.form_name_require');
  var requiredFieldEmail = (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.form_email_require');
  var requiredFieldPhone = (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.form_phone_require');
  var isInOperatingHours = (0, _get3.default)(setting, 'isInOperatingHours');
  var canSkip = !requiredFieldName && !requiredFieldPhone && !requiredFieldEmail;

  var onSubmit = function onSubmit() {
    var validateName = enableFieldName && requiredFieldName && (0, _isEmpty3.default)(name) ? false : true;
    var validateEmail = enableFieldEmail && requiredFieldEmail && (0, _isEmpty3.default)(email) ? false : true;
    var validatePhone = enableFieldPhone && requiredFieldPhone && (0, _isEmpty3.default)(phone) ? false : true;
    setSubmit(true);

    if (enablePrivacyPolicyConsent && !checkPrivacyPolicyConsent) return;
    if (!(0, _includes3.default)([validateName, validatePhone, validateEmail], false)) {
      dispatch((0, _actions.startConversation)(_websocket.BUTTON_STARTS.START_CONVERSATION, { name: name, email: email, phone: phone, isWorkingDay: setting.isInOperatingHours }));
      return;
    }

    if (canSkip) {
      dispatch((0, _actions.startConversation)(_websocket.BUTTON_STARTS.START_CONVERSATION, { name: name, email: email, phone: phone, isWorkingDay: setting.isInOperatingHours }));
    }
  };

  var getInputTextColor = function getInputTextColor(setting) {
    var activeTheme = (0, _get3.default)(setting, 'activeTheme');
    if (activeTheme === 'style-one') {
      return (0, _get3.default)(setting, 'screenForm.inputTextColor');
    } else if (activeTheme === 'style-two') {
      return (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor');
    } else {
      return (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor');
    }
  };

  // console.log('check: ', checkPrivacyPolicyConsent)
  return _react2.default.createElement(
    'div',
    { className: _userInfoForm2.default.userInfoFormContainer + ' bs-chat-box-form' },
    _react2.default.createElement(
      'div',
      { className: _userInfoForm2.default.form },
      _react2.default.createElement(
        'form',
        { onSubmit: handleSubmit(onSubmit), className: _userInfoForm2.default.userForm },
        _react2.default.createElement(
          'div',
          null,
          enableFieldName && _react2.default.createElement(_formInput2.default, {
            style: activeTheme,
            backgroundColor: (0, _get3.default)(setting, 'screenForm.inputBackgroundColor'),
            isRequired: requiredFieldName,
            textColor: getInputTextColor(setting),
            icon: _react2.default.createElement(_reactInlinesvg2.default, { src: _name2.default, style: { width: '12px', height: '12px' } }),
            placeholder: (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.form_name_placeholder'),
            onChange: function onChange(e) {
              return setName(e.target.value);
            },
            isValid: isSubmit ? (0, _isEmpty3.default)(name) : undefined,
            inputValue: name,
            placeholderColor: (0, _get3.default)(setting, 'screenForm.placeholderTextColor')
          })
        ),
        _react2.default.createElement(
          'div',
          null,
          enableFieldEmail && _react2.default.createElement(_formInput2.default, {
            style: activeTheme,
            backgroundColor: (0, _get3.default)(setting, 'screenForm.inputBackgroundColor'),
            isRequired: requiredFieldEmail,
            textColor: getInputTextColor(setting),
            icon: _react2.default.createElement(_reactInlinesvg2.default, { src: _email2.default, style: { width: '16px', height: '11px' } }),
            placeholder: (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.form_email_placeholder'),
            onChange: function onChange(e) {
              return setEmail(e.target.value);
            },
            isValid: isSubmit ? (0, _isEmpty3.default)(email) : undefined,
            inputValue: email,
            placeholderColor: (0, _get3.default)(setting, 'screenForm.placeholderTextColor')
          })
        ),
        _react2.default.createElement(
          'div',
          null,
          enableFieldPhone && _react2.default.createElement(_formInput2.default, {
            style: activeTheme,
            backgroundColor: (0, _get3.default)(setting, 'screenForm.inputBackgroundColor'),
            isRequired: requiredFieldPhone,
            textColor: getInputTextColor(setting),
            icon: _react2.default.createElement(_reactInlinesvg2.default, { style: { width: '16.8px', height: '16.8px' }, src: _phone2.default }),
            placeholder: (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.form_phone_placeholder'),
            onChange: function onChange(e) {
              return setPhone(e.target.value);
            },
            isValid: isSubmit ? (0, _isEmpty3.default)(phone) : undefined,
            inputValue: phone,
            placeholderColor: (0, _get3.default)(setting, 'screenForm.placeholderTextColor')
          })
        ),
        _react2.default.createElement(
          'div',
          null,
          enablePrivacyPolicyConsent && _react2.default.createElement(_formCheckbox2.default, {
            color: isSubmit && !checkPrivacyPolicyConsent ? 'red' : (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor'),
            label: privacyPolicyMessage,
            link: privacyPolicyLink,
            checked: checkPrivacyPolicyConsent,
            onChange: function onChange(checked) {
              return setCheckPrivacyPolicyConsent(checked);
            }
          })
        ),
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(_btnStartConversation2.default, { setting: setting })
        ),
        _react2.default.createElement(
          'div',
          null,
          canSkip && _react2.default.createElement(
            'div',
            {
              onClick: onSubmit,
              className: _userInfoForm2.default.skipWrapper,
              style: {
                color: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor')
              }
            },
            _react2.default.createElement(
              'span',
              null,
              (0, _get3.default)(setting, 'chatboxThemeSettings.commonSettings.skip_button_label')
            ),
            _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement(_reactInlinesvg2.default, {
                src: _skipForm2.default,
                style: {
                  width: '7.5px',
                  height: '4.8px',
                  marginLeft: '3.8px'
                }
              })
            )
          )
        )
      )
    )
  );
};

module.exports = exports['default'];