'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactFrameComponent = require('react-frame-component');

var _reactFrameComponent2 = _interopRequireDefault(_reactFrameComponent);

var _instagram = require('../icon/instagram.svg');

var _instagram2 = _interopRequireDefault(_instagram);

var _widgetIcon = require('../../commons/components/widget-icon');

var _widgetIcon2 = _interopRequireDefault(_widgetIcon);

var _tooltip = require('../tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Instagram = function (_Component) {
  (0, _inherits3.default)(Instagram, _Component);

  function Instagram(props) {
    (0, _classCallCheck3.default)(this, Instagram);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));

    _this.state = { isHover: false };
    return _this;
  }

  Instagram.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        iframeStyles = _props.iframeStyles,
        position = _props.position,
        setting = _props.setting,
        svgSize = _props.svgSize,
        component = _props.component;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor;

    var iconSize = (0, _get3.default)(setting, 'iconSize');
    var link = (0, _get3.default)(component, 'configurationData.link');
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactFrameComponent2.default,
        {
          initialContent: '<!DOCTYPE html><html><head>' + iframeStyles + '</head><body></body></html>',
          mountTarget: 'body',
          style: {
            width: iconSize,
            height: iconSize,
            position: 'absolute',
            bottom: position.bottom + 'px',
            right: position.right + 'px',
            transition: 'opacity 0.8s',
            zIndex: '9999997',
            maxWidth: iconSize,
            minWidth: iconSize,
            minHeight: iconSize,
            maxHeight: iconSize
          },
          allowtransparency: 'yes',
          frameBorder: '0'
        },
        _react2.default.createElement(_widgetIcon2.default, {
          iconBackgroundColor: iconBackgroundColor,
          iconSize: iconSize,
          iconSrc: _instagram2.default,
          iconTextColor: iconTextColor,
          svgSize: svgSize,
          onClick: function onClick() {
            link && window.open(link, '_blank');
          },
          handleHover: function handleHover(e) {
            return _this2.setState(e);
          }
        })
      ),
      this.state.isHover && _react2.default.createElement(_tooltip2.default, (0, _extends3.default)({}, this.props, this.state))
    );
  };

  return Instagram;
}(_react.Component);

exports.default = Instagram;
module.exports = exports['default'];