'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _throttle2 = require('lodash/throttle');

var _throttle3 = _interopRequireDefault(_throttle2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _reactFrameComponent = require('react-frame-component');

var _reactFrameComponent2 = _interopRequireDefault(_reactFrameComponent);

var _actions = require('../../store/actions');

var _liveChat = require('../icon/live-chat.svg');

var _liveChat2 = _interopRequireDefault(_liveChat);

var _widgetIcon = require('../../commons/components/widget-icon');

var _widgetIcon2 = _interopRequireDefault(_widgetIcon);

var _tooltip = require('../tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var numberOfNewMessages = _ref.numberOfNewMessages,
      props = _ref.props;
  var iframeStyles = props.iframeStyles,
      position = props.position,
      setting = props.setting,
      svgSize = props.svgSize;

  var _useState = (0, _react.useState)(false),
      isHover = _useState[0],
      setIsHover = _useState[1];

  var iconBackgroundColor = setting.iconBackgroundColor,
      iconTextColor = setting.iconTextColor;

  var iconSize = (0, _get3.default)(setting, 'iconSize');
  var dispatch = (0, _reactRedux.useDispatch)();
  var throttleOnClickIcon = (0, _react.useCallback)((0, _throttle3.default)(function () {
    dispatch((0, _actions.toggleChat)(setting));
  }, 300, { trailing: false }), []);

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      _reactFrameComponent2.default,
      {
        initialContent: '<!DOCTYPE html><html><head>' + iframeStyles + '</head><body></body></html>',
        mountTarget: 'body',
        style: {
          width: iconSize,
          height: iconSize,
          position: 'absolute',
          bottom: position.bottom + 'px',
          right: position.right + 'px',
          transition: 'opacity 0.8s',
          zIndex: '9999997',
          maxWidth: iconSize,
          minWidth: iconSize,
          minHeight: iconSize,
          maxHeight: iconSize
        },
        allowtransparency: 'yes',
        frameBorder: '0'
      },
      _react2.default.createElement(_widgetIcon2.default, {
        iconBackgroundColor: iconBackgroundColor,
        iconSize: iconSize,
        iconSrc: _liveChat2.default,
        iconTextColor: iconTextColor,
        svgSize: svgSize,
        onClick: throttleOnClickIcon,
        numberOfNewMessages: numberOfNewMessages,
        handleHover: function handleHover(e) {
          return setIsHover(e.isHover);
        }
      })
    ),
    isHover && _react2.default.createElement(_tooltip2.default, (0, _extends3.default)({}, props, { type: 'chat' }))
  );
};

module.exports = exports['default'];