'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _webrtc = require('../../webrtc');

var _webrtc2 = _interopRequireDefault(_webrtc);

var _hark = require('hark');

var hark = _interopRequireWildcard(_hark);

var _icon = require('../../../icon');

var _power = require('../power');

var _power2 = _interopRequireDefault(_power);

var _reactInlinesvg = require('react-inlinesvg');

var _reactInlinesvg2 = _interopRequireDefault(_reactInlinesvg);

var _endCall = require('../../../icon/end-call.svg');

var _endCall2 = _interopRequireDefault(_endCall);

var _calling = require('../../../icon/calling.svg');

var _calling2 = _interopRequireDefault(_calling);

var _avatar = require('../../../../commons/components/avatar');

var _avatar2 = _interopRequireDefault(_avatar);

var _countTime = require('../../../../commons/components/count-time');

var _countTime2 = _interopRequireDefault(_countTime);

var _websocket = require('../../../../connections/websocket');

var _websocket2 = require('../../../../commons/constants/websocket');

var _tenantInfo = require('../../../../commons/tenant-info');

var _constants = require('../../constants');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// https://medium.com/@BoltAssaults/autoplay-muted-html5-video-safari-ios-10-in-react-673ae50ba1f5
var isSafari = function isSafari() {
  var ua = navigator.userAgent.toLowerCase();
  return ua.indexOf('safari') > -1 && ua.indexOf('chrome') < 0;
};

var PageCalling = function (_Component) {
  (0, _inherits3.default)(PageCalling, _Component);

  function PageCalling(props) {
    (0, _classCallCheck3.default)(this, PageCalling);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));

    _this.state = {
      remoteStream: undefined,
      second: 0,
      minute: 0
    };

    _this.onClickStop = function () {
      var handleStopCall = _this.props.handleStopCall;

      handleStopCall && handleStopCall(_constants.CALL_STOP_REASON.SUBSCRIBER_STOP);
      clearInterval(_this.interval);
      clearInterval(_this.intervalSendInCallSignal);
    };

    _this.handleUpdateRemotePeerConnection = function () {
      var callInfo = _this.props.callInfo;

      var remotePeerConnectionInfo = (0, _get3.default)(callInfo, 'callData.adminPeerConnectionInfo');
      // console.log("configure WebRTC connection", remotePeerConnectionInfo);
      _webrtc2.default.updateRemotePeerConnection(remotePeerConnectionInfo);
    };

    _this.handleGotGotRemoteStreamHandler = function () {
      _webrtc2.default.onGotRemoteStreamHandler(function (remoteStream) {
        // console.log("webRTC.onGotRemoteStreamHandler: ", remoteStream);
        var adminSpeechEvents = hark(remoteStream, {});
        adminSpeechEvents.on('speaking', function () {
          console.log('AdminTalking');
        });

        _this.setState({
          remoteStream: remoteStream
        });

        // adminSpeechEvents.on("stopped_speaking", () => {});
        // const localStream = webRTC.getLocalStream();
        // const localSpeechEvents = hark(localStream, {});
        // localSpeechEvents.on("speaking", () => {
        //   console.log("YouTalking");
        // });
        // localSpeechEvents.on("stopped_speaking", () => {});
      });
    };

    _this.audioParentRef = _react2.default.createRef();
    return _this;
  }

  PageCalling.prototype.updateRemoteAudioStream = function updateRemoteAudioStream() {
    // console.log("updateRemoteAudioStream");
    var audio = this.audioParentRef.current.children[0];
    if (audio && this.state.remoteStream && audio.srcObject !== this.state.remoteStream) {
      // console.log("setup audio: ", audio);
      if ('srcObject' in audio) {
        // console.log("set audio.srcObject");
        audio.srcObject = this.state.remoteStream;
      } else if ('src' in audio && window.URL.createObjectURL) {
        // console.log("set audio.src");
        audio.src = window.URL.createObjectURL(this.state.remoteStream);
      }

      if (isSafari()) {
        // console.log("isSafari");
        audio.controls = false;
        audio.playsinline = true;
        audio.muted = false;
        //audio.setAttribute("muted", "");
        audio.autoplay = true;

        if (audio.load) {
          // console.log("audio.load");
          audio.load();
        }

        if (audio.play) {
          console.log('audio.play');
          setTimeout(function () {
            var promise = audio.play();
            if (promise.then) {
              promise.then(function () {
                // console.log("play successfully");
              }).catch(function (err) {
                console.log('play failed', err);
              });
            } else {
              // console.log("is not a promise");
            }
          }, 0);
        }
      } else {
        audio.muted = false;
        audio.controls = false;
        audio.playsinline = true;
        audio.autoplay = true;
        audio.load();
        setTimeout(function () {
          var promise = audio.play();
          if (promise.then) {
            promise.then(function () {
              // console.log("play successfully");
            }).catch(function (err) {
              console.log('play failed', err);
            });
          }
        }, 0);
      }

      audio.onloadedmetadata = function () {
        if (isSafari()) {
          // audio.controls = false;
          // audio.playsinline = true;
          // audio.muted = true;
          // audio.setAttribute("muted", "");
          // audio.autoplay = true;
          // if (audio.play) {
          //   console.log("audio.play");
          //   setTimeout(() => {
          //     const promise = audio.play();
          //     if (promise.then) {
          //       promise
          //         .then(() => {
          //           console.log("play successfully");
          //         })
          //         .catch((err) => {
          //           console.log("play failed", err);
          //         });
          //     }
          //   }, 0);
          // }
        } else {
          setTimeout(function () {
            var promise = audio.play();
            if (promise.then) {
              promise.then(function () {
                console.log('play successfully');
              }).catch(function (err) {
                console.log('play failed', err);
              });
            }
          }, 0);
        }
      };
    }
  };

  PageCalling.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.handleUpdateRemotePeerConnection();
    this.handleGotGotRemoteStreamHandler();
    this.updateRemoteAudioStream();
    // Count time
    this.interval = setInterval(function () {
      if (_this2.state.second === 59) {
        _this2.setState({
          second: 0,
          minute: _this2.state.minute + 1
        });
      } else {
        _this2.setState({
          second: _this2.state.second + 1
        });
      }
    }, 1000);
    // Interval send ttl
    this.intervalSendInCallSignal = setInterval(function () {
      (0, _websocket.sendMessage)({
        group: _websocket2.GROUP.CALL,
        type: _websocket2.TYPE.CALL.UPDATE_IN_CALL_SIGNAL,
        payload: { callId: (0, _get3.default)(_this2.props.callInfo, ['callData', 'id']) },
        tenantInfo: (0, _tenantInfo.getTenantInfo)()
      });
    }, 15000);

    window.parent.onbeforeunload = function () {
      return 'Do not reload page';
    };
    window.parent.addEventListener('unload', this.onClickStop);
  };

  PageCalling.prototype.componentDidUpdate = function componentDidUpdate() {
    this.updateRemoteAudioStream();
  };

  PageCalling.prototype.componentWillUnmount = function componentWillUnmount() {
    this.interval && clearInterval(this.interval);
    this.intervalSendInCallSignal && clearInterval(this.intervalSendInCallSignal);
    window.parent.onbeforeunload = null;
    window.parent.removeEventListener('unload', this.onClickStop);
  };

  PageCalling.prototype.render = function render() {
    var _props = this.props,
        setting = _props.setting,
        callInfo = _props.callInfo,
        isMobileMode = _props.isMobileMode;
    var _state = this.state,
        minute = _state.minute,
        second = _state.second;

    var adminInfo = (0, _get3.default)(callInfo, ['callData', 'admin']);
    var adminAvatar = (0, _get3.default)(adminInfo, 'avatar');
    var adminName = (0, _get3.default)(adminInfo, 'displayName') || 'Admin name';
    var isCustomAdminInfo = (0, _get3.default)(setting, 'callThemeSettings.isCustomAdminInfo');
    return _react2.default.createElement(
      'div',
      { className: _styles2.default.container },
      _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { className: _styles2.default.timeContent },
          _react2.default.createElement(
            'div',
            { className: _styles2.default.icon },
            _react2.default.createElement(_reactInlinesvg2.default, { src: _calling2.default })
          ),
          _react2.default.createElement(_countTime2.default, { minute: minute, second: second })
        )
      ),
      _react2.default.createElement(
        'div',
        { className: _styles2.default.infoContent },
        _react2.default.createElement(
          'div',
          { className: _styles2.default.userAvatar },
          _react2.default.createElement('div', {
            style: {
              backgroundColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor'),
              color: 'transparent'
            },
            className: _styles2.default.wrapOpacity1
          }),
          _react2.default.createElement('div', { style: { backgroundColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor') }, className: _styles2.default.wrapOpacity2 }),
          !isCustomAdminInfo ? _react2.default.createElement(
            'div',
            { style: { backgroundColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor') }, className: _styles2.default.wrap },
            _react2.default.createElement(
              'div',
              { className: _styles2.default.avartar },
              adminAvatar ? _react2.default.createElement(
                'div',
                { style: { width: '60px', height: '60px' } },
                _react2.default.createElement(_avatar2.default, { size: '60px', src: adminAvatar })
              ) : _react2.default.createElement(_avatar2.default, { size: '30px', src: _icon.CALLING_ICON.CALLING3 })
            )
          ) : _react2.default.createElement(
            'div',
            { style: { backgroundColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor') }, className: _styles2.default.wrap },
            _react2.default.createElement(
              'div',
              { className: _styles2.default.avartar },
              _react2.default.createElement(_avatar2.default, { size: '60px', src: (0, _get3.default)(setting, 'callThemeSettings.informationSettings.callee_avatar') })
            )
          )
        ),
        _react2.default.createElement(
          'div',
          { style: { marginTop: '9px' } },
          _react2.default.createElement(
            'span',
            { className: _styles2.default.userName },
            isCustomAdminInfo ? (0, _get3.default)(setting, 'callThemeSettings.informationSettings.callee_name') : adminName
          )
        )
      ),
      _react2.default.createElement(
        'div',
        { className: _styles2.default.endButton, onClick: this.onClickStop },
        _react2.default.createElement(
          'div',
          { className: _styles2.default.iconContainer },
          _react2.default.createElement(_reactInlinesvg2.default, { src: _endCall2.default })
        )
      ),
      _react2.default.createElement(
        'div',
        { className: _styles2.default.power },
        _react2.default.createElement(_power2.default, { setting: setting })
      ),
      _react2.default.createElement('div', {
        ref: this.audioParentRef,
        style: { display: 'none' },
        dangerouslySetInnerHTML: {
          __html: '\n                <video\n                  loop\n                  muted\n                  autoplay\n                  playsinline\n                  preload="metadata"\n                >\n                </video>'
        }
      }),
      _react2.default.createElement(_icon.CloseCallIcon, { className: _styles2.default.closeIcon })
    );
  };

  return PageCalling;
}(_react.Component);

exports.default = PageCalling;
module.exports = exports['default'];