'use strict';

exports.__esModule = true;

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _power = require('../power');

var _power2 = _interopRequireDefault(_power);

var _reactInlinesvg = require('react-inlinesvg');

var _reactInlinesvg2 = _interopRequireDefault(_reactInlinesvg);

var _callEnded = require('../../../icon/call-ended.svg');

var _callEnded2 = _interopRequireDefault(_callEnded);

var _reactStarRatings = require('react-star-ratings');

var _reactStarRatings2 = _interopRequireDefault(_reactStarRatings);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

var _icon = require('../../../icon');

var _reactRedux = require('react-redux');

var _updateCall = require('../../../../store/actions/update-call.action');

var _constants = require('../../constants');

var _avatar = require('../../../../commons/components/avatar');

var _avatar2 = _interopRequireDefault(_avatar);

var _countTime = require('../../../../commons/components/count-time');

var _countTime2 = _interopRequireDefault(_countTime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (props) {
  var dispatch = (0, _reactRedux.useDispatch)();
  var setting = props.setting,
      callInfo = props.callInfo,
      status = props.status,
      isMobileMode = props.isMobileMode;

  var _useState = (0, _react.useState)(0),
      rating = _useState[0],
      setRating = _useState[1];

  var ratingColor = (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor');
  var totalDuration = (0, _get3.default)(callInfo, 'callData.totalDuration');
  var adminAvatar = (0, _get3.default)(callInfo, ['callData', 'admin', 'avatar']);

  var minute = 0;
  var second = 0;
  if (totalDuration) {
    minute = Math.floor(totalDuration / 60);
    second = totalDuration % 60;
  }

  var onChangeRating = function onChangeRating(newRating) {
    var setting = props.setting;

    setRating(newRating);
    dispatch((0, _updateCall.updateCallInfo)({ id: callInfo.callData.id, rating: newRating }, _constants.CALL_STATUS.COMPLETED_RATING, setting.channelId));
  };

  var onClickMakeAnotherCall = function onClickMakeAnotherCall() {
    var handleMakeAnotherCall = props.handleMakeAnotherCall;

    handleMakeAnotherCall && handleMakeAnotherCall();
  };
  var isCustomAdminInfo = (0, _get3.default)(setting, 'callThemeSettings.isCustomAdminInfo');
  return _react2.default.createElement(
    'div',
    { className: _styles2.default.container },
    status === _constants.CALL_STATUS.COMPLETED_RATING || rating !== 0 ? _react2.default.createElement(
      'div',
      { className: _styles2.default.ratingResult },
      _react2.default.createElement(_reactStarRatings2.default, {
        rating: rating || (0, _get3.default)(props.callInfo, ['callData', 'rating']),
        starRatedColor: ratingColor,
        starHoverColor: ratingColor,
        numberOfStars: 5,
        name: 'rating',
        starDimension: '28.8px',
        starSpacing: '7.7px'
      }),
      _react2.default.createElement(
        'span',
        { className: _styles2.default.title },
        (0, _get3.default)(setting, 'callThemeSettings.commonSettings.rating_text')
      ),
      _react2.default.createElement(
        'div',
        { className: _styles2.default.button },
        _react2.default.createElement(_button2.default, {
          setting: setting,
          text: (0, _get3.default)(setting, 'callThemeSettings.commonSettings.make_another_call_label'),
          callIcon: true,
          onClick: onClickMakeAnotherCall
        })
      )
    ) : _react2.default.createElement(
      'div',
      { className: _styles2.default.content },
      _react2.default.createElement(
        'div',
        { className: _styles2.default.mainContain },
        _react2.default.createElement(
          'div',
          { className: _styles2.default.endtimeContent },
          _react2.default.createElement(
            'div',
            { className: _styles2.default.icon },
            _react2.default.createElement(_reactInlinesvg2.default, { src: _callEnded2.default })
          ),
          _react2.default.createElement(
            'div',
            { className: _styles2.default.time, style: { fontFamily: 'Open Sans' } },
            _react2.default.createElement(_countTime2.default, { minute: minute, second: second }),
            _react2.default.createElement(
              'span',
              { style: { marginLeft: '5px' } },
              ' Call ended '
            )
          )
        ),
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            'div',
            { className: _styles2.default.userAvatar },
            _react2.default.createElement('div', { style: { backgroundColor: '#d6d6d6' }, className: _styles2.default.wrapOpacity1 }),
            _react2.default.createElement('div', { style: { backgroundColor: '#d6d6d6' }, className: _styles2.default.wrapOpacity2 }),
            !isCustomAdminInfo ? _react2.default.createElement(
              'div',
              { style: { backgroundColor: '#d6d6d6' }, className: _styles2.default.wrap },
              _react2.default.createElement(
                'div',
                { className: _styles2.default.avartar },
                adminAvatar ? _react2.default.createElement(
                  'div',
                  { style: { width: '60px', height: '60px' } },
                  _react2.default.createElement(_avatar2.default, { size: '60px', src: adminAvatar })
                ) : _react2.default.createElement(_avatar2.default, { size: '30px', src: _icon.CALLING_ICON.CALLING3 })
              )
            ) : _react2.default.createElement(
              'div',
              { style: { backgroundColor: (0, _get3.default)(setting, 'iconTextColor') }, className: _styles2.default.wrap },
              _react2.default.createElement(
                'div',
                { className: _styles2.default.avartar },
                _react2.default.createElement(_avatar2.default, { size: '60px', src: (0, _get3.default)(setting, 'callThemeSettings.informationSettings.callee_avatar') })
              )
            )
          ),
          _react2.default.createElement(
            'div',
            { className: _styles2.default.ratingContent },
            _react2.default.createElement(
              'span',
              { className: _styles2.default.text },
              (0, _get3.default)(setting, 'callThemeSettings.commonSettings.pre_rating_text')
            ),
            _react2.default.createElement(_reactStarRatings2.default, {
              rating: rating,
              starRatedColor: ratingColor,
              starHoverColor: ratingColor,
              changeRating: function changeRating(newRating, name) {
                return onChangeRating(newRating);
              } // setRating(newRating)
              , numberOfStars: 5,
              name: 'rating',
              starDimension: '27.5px',
              starSpacing: '7.7px'
            })
          )
        )
      ),
      _react2.default.createElement(_power2.default, { setting: setting })
    ),
    status === _constants.CALL_STATUS.COMPLETED_RATING || rating !== 0 && _react2.default.createElement(_power2.default, { setting: setting }),
    _react2.default.createElement(_icon.CloseCallIcon, { iconTextColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor'), className: _styles2.default.closeIcon })
  );
};

module.exports = exports['default'];