'use strict';

exports.__esModule = true;

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _icon = require('../../../../icon');

var _callAnimation = require('../call-animation');

var _callAnimation2 = _interopRequireDefault(_callAnimation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var setting = _ref.setting,
      isInConfigurationMode = _ref.isInConfigurationMode,
      demoData = _ref.demoData,
      isMobileMode = _ref.isMobileMode;

  var activeTheme = (0, _get3.default)(setting, 'activeTheme');
  var iconTextColor = (0, _get3.default)(setting, 'iconTextColor');

  return _react2.default.createElement(
    'div',
    {
      className: '' + _styles2.default.headerContainer,
      style: {
        background: (0, _get3.default)(setting, 'iconBackgroundColor'),
        color: iconTextColor,
        borderRadius: isMobileMode ? '0px' : ' 18px 18px 0 0'
      }
    },
    _react2.default.createElement(_callAnimation2.default, { bgColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor'), iconColor: '#fff' }),
    _react2.default.createElement(
      'div',
      { className: _styles2.default.textContent },
      _react2.default.createElement(
        'div',
        { className: _styles2.default.headerRow },
        _react2.default.createElement(
          'span',
          {
            style: {
              color: iconTextColor
            }
          },
          (0, _get3.default)(setting, 'callThemeSettings.' + activeTheme + '.header.header_text_1')
        )
      )
    ),
    _react2.default.createElement(_icon.CloseCallIcon, { className: _styles2.default.closeIcon, iconTextColor: iconTextColor })
  );
};

module.exports = exports['default'];