'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _constants = require('../../constants');

var _icon = require('../../../icon');

var _power = require('../power');

var _power2 = _interopRequireDefault(_power);

var _reactInlinesvg = require('react-inlinesvg');

var _reactInlinesvg2 = _interopRequireDefault(_reactInlinesvg);

var _endCall = require('../../../icon/end-call.svg');

var _endCall2 = _interopRequireDefault(_endCall);

var _avatar = require('../../../../commons/components/avatar');

var _avatar2 = _interopRequireDefault(_avatar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PageInitCall = function (_Component) {
  (0, _inherits3.default)(PageInitCall, _Component);

  function PageInitCall(props) {
    (0, _classCallCheck3.default)(this, PageInitCall);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));

    _this.onClickStop = function () {
      var handleStopCall = _this.props.handleStopCall;
      //ToDo: Server is based on TotalDuration. Need to refactor

      handleStopCall && handleStopCall(_constants.CALL_STOP_REASON.SUBSCRIBER_STOP, 0);
      clearTimeout(_this.setTimeoutStopCall);
    };

    return _this;
  }

  PageInitCall.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    // Auto stop call after init 30s but nobody accepting this call
    // console.log("handleAutoStopCall");
    this.setTimeoutStopCall = setTimeout(function () {
      _this2.props.handleStopCall(_constants.CALL_STOP_REASON.SUBSCRIBER_AUTO_STOP_WHEN_TIMEOUT);
    }, 60000);
    window.parent.onbeforeunload = function () {
      return 'Do not reload page';
    };
    window.parent.addEventListener('unload', this.onClickStop);
  };

  PageInitCall.prototype.componentWillUnmount = function componentWillUnmount() {
    this.setTimeoutStopCall && clearInterval(this.setTimeoutStopCall);
    window.parent.onbeforeunload = null;
    window.parent.removeEventListener('unload', this.onClickStop);
  };

  PageInitCall.prototype.render = function render() {
    var _props = this.props,
        callInfo = _props.callInfo,
        setting = _props.setting,
        isMobileMode = _props.isMobileMode;

    var status = (0, _get3.default)(callInfo, ['callData', 'status']);
    var subscriberName = (0, _get3.default)(callInfo.callData, ['callInfo', 'name']);
    var isCustomAvatar = (0, _get3.default)(setting, 'callThemeSettings.isCustomProjectAvatar');
    return _react2.default.createElement(
      'div',
      { className: _styles2.default.container },
      status === _constants.CALL_STATUS.INITIATED && _react2.default.createElement(
        'div',
        { className: _styles2.default.callStatus },
        'Initializing...'
      ),
      status === _constants.CALL_STATUS.RINGING && _react2.default.createElement(
        'div',
        { className: _styles2.default.callStatus },
        'Ringing...'
      ),
      _react2.default.createElement(
        'div',
        { className: _styles2.default.infoContent },
        _react2.default.createElement(
          'div',
          { className: _styles2.default.userAvatar },
          _react2.default.createElement('div', {
            style: {
              backgroundColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor'),
              color: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor')
            },
            className: _styles2.default.wrapOpacity1
          }),
          _react2.default.createElement('div', { style: { backgroundColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor') }, className: _styles2.default.wrapOpacity2 }),
          !isCustomAvatar ? _react2.default.createElement(
            'div',
            { style: { backgroundColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor') }, className: _styles2.default.wrap },
            _react2.default.createElement(
              'div',
              { className: _styles2.default.icon },
              _react2.default.createElement('img', { src: _icon.CALLING_ICON.CALLING1 })
            ),
            _react2.default.createElement(
              'div',
              { className: _styles2.default.icon },
              _react2.default.createElement('img', { src: _icon.CALLING_ICON.CALLING2 })
            ),
            _react2.default.createElement(
              'div',
              { className: _styles2.default.icon },
              _react2.default.createElement('img', { src: _icon.CALLING_ICON.CALLING3 })
            )
          ) : _react2.default.createElement(
            'div',
            { style: { backgroundColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor') }, className: _styles2.default.wrap },
            _react2.default.createElement(_avatar2.default, { size: '60px', src: (0, _get3.default)(setting, 'callThemeSettings.informationSettings.project_avatar') })
          )
        ),
        _react2.default.createElement(
          'div',
          { style: { marginTop: '9px' } },
          _react2.default.createElement(
            'span',
            { className: _styles2.default.userName },
            (0, _get3.default)(setting, 'callThemeSettings.informationSettings.project_name')
          )
        )
      ),
      _react2.default.createElement(
        'div',
        { className: _styles2.default.endButton, onClick: this.onClickStop },
        _react2.default.createElement(
          'div',
          { className: _styles2.default.iconContainer },
          _react2.default.createElement(_reactInlinesvg2.default, { src: _endCall2.default })
        )
      ),
      _react2.default.createElement(
        'div',
        { className: _styles2.default.power },
        _react2.default.createElement(_power2.default, { setting: setting })
      ),
      _react2.default.createElement(_icon.CloseCallIcon, { className: _styles2.default.closeIcon })
    );
  };

  return PageInitCall;
}(_react.Component);

exports.default = PageInitCall;
module.exports = exports['default'];