'use strict';

exports.__esModule = true;

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _power = require('../power');

var _power2 = _interopRequireDefault(_power);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

var _leaveInfo = require('../leave-info');

var _leaveInfo2 = _interopRequireDefault(_leaveInfo);

var _icon = require('../../../icon');

var _call = require('../../../icon/call.svg');

var _call2 = _interopRequireDefault(_call);

var _reactInlinesvg = require('react-inlinesvg');

var _reactInlinesvg2 = _interopRequireDefault(_reactInlinesvg);

var _reactRedux = require('react-redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getBorderRadiusValue = function getBorderRadiusValue(activeTheme) {
  if (activeTheme === 'style-one') {
    return '0px';
  }
  if (activeTheme === 'style-two') {
    return '30px';
  }
  return '10px';
};

exports.default = function (props) {
  var setting = props.setting;

  var _useState = (0, _react.useState)(false),
      wannaLeaveInfo = _useState[0],
      setWannaLeaveInfo = _useState[1];

  var phoneNumber = (0, _get3.default)(setting, 'callComponent.phoneNumber');
  var activeTheme = (0, _get3.default)(setting, 'activeTheme');
  var borderRadius = getBorderRadiusValue(activeTheme);
  var alreadySaveInfo = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get3.default)(store, 'behavior.alreadySubmitUserInfo');
  });

  return _react2.default.createElement(
    'div',
    { className: _styles2.default.container },
    wannaLeaveInfo && !alreadySaveInfo ? _react2.default.createElement(_leaveInfo2.default, { setting: setting, isNoSupport: true, onCloseForm: function onCloseForm() {
        return setLeaveInfo(false);
      } }) : _react2.default.createElement(
      'div',
      { className: _styles2.default.content },
      _react2.default.createElement(
        'span',
        { style: { color: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor') }, className: _styles2.default.title },
        (0, _get3.default)(setting, 'callThemeSettings.commonSettings.no_support_title')
      ),
      !alreadySaveInfo && _react2.default.createElement(
        'span',
        { className: _styles2.default.description },
        (0, _get3.default)(setting, 'callThemeSettings.commonSettings.no_spport_description')
      ),
      !alreadySaveInfo && _react2.default.createElement(_button2.default, {
        setting: setting,
        onClick: function onClick() {
          return setWannaLeaveInfo(true);
        },
        text: (0, _get3.default)(setting, 'callThemeSettings.commonSettings.no_support_label'),
        isBorder: true,
        width: '100%'
      }),
      phoneNumber && _react2.default.createElement(
        'div',
        { style: { marginTop: '24px' } },
        _react2.default.createElement(
          'a',
          {
            style: {
              background: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor'),
              borderRadius: borderRadius
            },
            className: _styles2.default.phoneCallButton,
            href: 'tel:' + phoneNumber
          },
          _react2.default.createElement(_reactInlinesvg2.default, { className: _styles2.default.icon, src: _call2.default }),
          phoneNumber
        )
      )
    ),
    _react2.default.createElement(_power2.default, { setting: setting }),
    _react2.default.createElement(_icon.CloseCallIcon, { iconTextColor: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor'), className: _styles2.default.closeIcon })
  );
};

module.exports = exports['default'];