'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

var _header = require('../header');

var _header2 = _interopRequireDefault(_header);

var _power = require('../power');

var _power2 = _interopRequireDefault(_power);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PageStartCall = function (_Component) {
  (0, _inherits3.default)(PageStartCall, _Component);

  function PageStartCall() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, PageStartCall);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.handleChangeSpeaker = function (e) {
      var _this$props = _this.props,
          handleSelectDevices = _this$props.handleSelectDevices,
          selectedMicrophoneId = _this$props.selectedMicrophoneId;

      handleSelectDevices && handleSelectDevices(e.target.value, selectedMicrophoneId);
    }, _this.handleChangeMicrophone = function (e) {
      var _this$props2 = _this.props,
          handleSelectDevices = _this$props2.handleSelectDevices,
          selectedSpeakerId = _this$props2.selectedSpeakerId;

      handleSelectDevices && handleSelectDevices(selectedSpeakerId, e.target.value);
    }, _this.handleClickCall = function () {
      var _this$props3 = _this.props,
          handleStartCall = _this$props3.handleStartCall,
          selectedMicrophoneId = _this$props3.selectedMicrophoneId,
          selectedSpeakerId = _this$props3.selectedSpeakerId;

      handleStartCall && handleStartCall(selectedSpeakerId, selectedMicrophoneId);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  PageStartCall.prototype.render = function render() {
    var _props = this.props,
        selectedMicrophoneId = _props.selectedMicrophoneId,
        selectedSpeakerId = _props.selectedSpeakerId,
        callInfo = _props.callInfo;
    var _props2 = this.props,
        devices = _props2.devices,
        setting = _props2.setting,
        isMobileMode = _props2.isMobileMode;


    var speakers = (devices || []).filter(function (device) {
      return device.kind === 'audiooutput';
    });

    var microphones = (devices || []).filter(function (device) {
      return device.kind === 'audioinput';
    });

    selectedSpeakerId = selectedSpeakerId || (!(0, _isEmpty3.default)(speakers) ? speakers[0].deviceId : undefined);
    selectedMicrophoneId = selectedMicrophoneId || (!(0, _isEmpty3.default)(microphones) ? microphones[0].deviceId : undefined);

    return _react2.default.createElement(
      'div',
      { className: _styles2.default.container },
      _react2.default.createElement(_header2.default, { setting: setting, isMobileMode: isMobileMode }),
      _react2.default.createElement(
        'div',
        { className: _styles2.default.content },
        _react2.default.createElement(
          'div',
          { className: _styles2.default.deviceSetting },
          _react2.default.createElement(
            'div',
            { className: _styles2.default.labelContainer },
            _react2.default.createElement(
              'div',
              { style: { color: (0, _get3.default)(setting, 'screenConversation.rightSideBackgroundColor') }, className: _styles2.default.label },
              (0, _get3.default)(setting, 'callThemeSettings.commonSettings.start_call__choose_your_input_device') || 'Choose your input device'
            )
          ),
          _react2.default.createElement(
            'div',
            { className: _styles2.default.deviceStatus },
            _react2.default.createElement(
              'select',
              { onChange: this.handleChangeMicrophone, value: selectedMicrophoneId },
              microphones.map(function (mic) {
                return _react2.default.createElement(
                  'option',
                  { key: mic.deviceId, value: mic.deviceId },
                  mic.label
                );
              })
            )
          )
        ),
        _react2.default.createElement(
          'div',
          { className: _styles2.default.btnCallWrapper },
          _react2.default.createElement(
            'div',
            {
              style: {
                width: '100%',
                paddingLeft: '39px',
                paddingRight: '39px'
              }
            },
            _react2.default.createElement(_button2.default, {
              isLoading: (0, _get3.default)(this.props, 'callInfo.callData.status') === 'Connecting',
              setting: setting,
              onClick: this.handleClickCall,
              callIcon: true,
              color: '#fff',
              text: (0, _get3.default)(setting, 'callThemeSettings.commonSettings.call_now_label'),
              width: 'min-content'
            })
          )
        )
      ),
      _react2.default.createElement(_power2.default, { setting: setting })
    );
  };

  return PageStartCall;
}(_react.Component);

exports.default = PageStartCall;
module.exports = exports['default'];