'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _find2 = require('lodash/find');

var _find3 = _interopRequireDefault(_find2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _includes2 = require('lodash/includes');

var _includes3 = _interopRequireDefault(_includes2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactFrameComponent = require('react-frame-component');

var _reactFrameComponent2 = _interopRequireDefault(_reactFrameComponent);

var _callWidget = require('../icon/call-widget.svg');

var _callWidget2 = _interopRequireDefault(_callWidget);

var _actions = require('../../store/actions');

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _noSupport = require('./components/no-support');

var _noSupport2 = _interopRequireDefault(_noSupport);

var _getPermission = require('./components/get-permission');

var _getPermission2 = _interopRequireDefault(_getPermission);

var _startCall = require('./components/start-call');

var _startCall2 = _interopRequireDefault(_startCall);

var _initCall = require('./components/init-call');

var _initCall2 = _interopRequireDefault(_initCall);

var _calling = require('./components/calling');

var _calling2 = _interopRequireDefault(_calling);

var _complete = require('./components/complete');

var _complete2 = _interopRequireDefault(_complete);

var _busyLine = require('./components/busy-line');

var _busyLine2 = _interopRequireDefault(_busyLine);

var _constants = require('./constants');

var _widgetIcon = require('../../commons/components/widget-icon');

var _widgetIcon2 = _interopRequireDefault(_widgetIcon);

var _layout = require('./components/layout');

var _layout2 = _interopRequireDefault(_layout);

var _tooltip = require('../tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PhoneCall = function (_Component) {
  (0, _inherits3.default)(PhoneCall, _Component);

  function PhoneCall(props) {
    var _this2 = this;

    (0, _classCallCheck3.default)(this, PhoneCall);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));

    _this.handleClickCall = function () {
      _this.props.actions.toggleCall();
    };

    _this.handleGetPermission = function (_ref) {
      var isAllow = _ref.isAllow;

      _this.props.actions.updateMediaPermission(isAllow);
      _this.props.actions.checkMediaDevice();
    };

    _this.handleStartCall = function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(speakerId, microphoneId) {
        var setting;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                setting = _this.props.setting;

                _this.props.actions.startCall({ speakerId: speakerId, microphoneId: microphoneId }, setting.channelId);

              case 2:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x, _x2) {
        return _ref2.apply(this, arguments);
      };
    }();

    _this.handleSelectDevices = function (speakerId, microphoneId) {
      _this.props.actions.selectDevices({ speakerId: speakerId, microphoneId: microphoneId });
    };

    _this.handleStopCall = function (stopReason, totalDuration) {
      if (_this.props.isInConfigurationMode) return;
      var _this$props = _this.props,
          callInfo = _this$props.callInfo,
          setting = _this$props.setting;

      _this.props.actions.stopCall(callInfo.callData, { stopReason: stopReason || _constants.CALL_STOP_REASON.SUBSCRIBER_STOP, totalDuration: totalDuration }, setting.channelId);
    };

    _this.calculateWidgetPosition = function () {
      var _this$props2 = _this.props,
          position = _this$props2.position,
          area = _this$props2.area,
          setting = _this$props2.setting,
          showChat = _this$props2.showChat,
          rect = _this$props2.rect,
          isSettingCollapse = _this$props2.isSettingCollapse,
          isSettingLeftBottom = _this$props2.isSettingLeftBottom,
          isSettingVertical = _this$props2.isSettingVertical,
          marginBottom = _this$props2.marginBottom,
          marginLeft = _this$props2.marginLeft,
          marginRight = _this$props2.marginRight;
      var iconSize = setting.iconSize,
          iconMargin = setting.iconMargin;

      var chatboxPosition = (0, _get3.default)(setting, 'chatboxComponent.position');
      var leftBottomAlign = (0, _get3.default)(setting, 'leftBottomAlign');
      var rightBottomAlign = (0, _get3.default)(setting, 'rightBottomAlign');
      var windowWidth = rect.width;
      var bottom = 10;
      var right = 0;
      var width = 380;
      var isChatBoxInSameArea = area === chatboxPosition;
      var isLeftBottomAlignHorizontal = leftBottomAlign === 'horizontal';
      var isRightBottomAlignHorizontal = rightBottomAlign === 'horizontal';
      if (isSettingCollapse) {
        if (isSettingLeftBottom) {
          if (showChat) {
            if (isSettingVertical) {
              right = position.right - width - width - iconMargin - iconMargin;
              bottom = marginBottom;
            } else {
              bottom = marginBottom + 10 + iconSize;
              right = windowWidth - marginRight - width - 10 - width - 10;
            }
          } else {
            // Don't care the chatbox now in this logic branch
            if (isSettingVertical) {
              right = position.right - width - iconMargin;
              bottom = marginBottom;
            } else {
              bottom = marginBottom + 10 + iconSize;
              right = windowWidth - width - marginLeft;
            }
          }
        } else {
          if (showChat) {
            if (isSettingVertical) {
              right = position.right + 380 + marginRight + iconSize + 10;
              bottom = marginBottom;
            } else {
              bottom = marginBottom + 10 + iconSize;
              right = marginRight + width + 10;
            }
          } else {
            if (isSettingVertical) {
              bottom = marginBottom;
              right = marginRight + iconSize + 10;
            } else {
              bottom = marginBottom + iconSize + 10;
              right = marginRight;
            }
          }
        }
      } else {
        if (isSettingLeftBottom) {
          // If chatbox is in them same area and showing.
          if (showChat) {
            if (isSettingVertical) {
              bottom = marginBottom;
              right = position.right - width - width - iconMargin - iconMargin;
            } else {
              bottom = marginBottom + 10 + iconSize;
              right = windowWidth - marginLeft - 10 - width - width;
            }
          } else {
            // Don't care the chatbox now in this logic branch
            if (isSettingVertical) {
              bottom = marginBottom;
              right = windowWidth - width - 10 - marginLeft - iconSize;
            } else {
              bottom = marginBottom + iconSize + iconMargin;
              right = windowWidth - width - marginLeft;
            }
          }
        } else {
          if (showChat) {
            if (isSettingVertical) {
              bottom = marginBottom;
              right = marginBottom + 10 + +iconSize + width + 10;
            } else {
              right = width + 10 + marginRight;
              bottom = marginBottom + 10 + iconSize;
            }
          } else {
            if (isSettingVertical) {
              right = marginRight + 10 + iconSize;
              bottom = marginBottom;
            } else {
              right = marginRight;
              bottom = marginBottom + 10 + iconSize;
            }
          }
        }
      }
      return { bottom: bottom, right: right, width: width };
    };

    _this.state = { isHover: false };
    _this.iframeRef = _react2.default.createRef();
    return _this;
  }

  PhoneCall.prototype.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    if (prevProps.iframeStyles !== this.props.iframeStyles) {
      if (this.iframeRef.current) {
        var stylesheetNode = (0, _find3.default)(this.iframeRef.current.node.contentDocument.styleSheets, function (node) {
          return (0, _get3.default)(node, 'ownerNode.className') === 'iframe-boostcrm';
        });

        if (stylesheetNode && stylesheetNode.ownerNode) {
          stylesheetNode.ownerNode.outerHTML = this.props.iframeStyles;
        }
      }
    }
  };

  PhoneCall.prototype.componentDidMount = function () {
    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              this.props.actions.checkMediaDevice();

            case 1:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function componentDidMount() {
      return _ref3.apply(this, arguments);
    }

    return componentDidMount;
  }();

  PhoneCall.prototype.renderCallWidget = function renderCallWidget() {
    var _this3 = this,
        _ref4;

    var _props = this.props,
        demoData = _props.demoData,
        isInConfigurationMode = _props.isInConfigurationMode,
        isSettingLeftBottom = _props.isSettingLeftBottom;

    var showCall = (0, _get3.default)(this.props, 'callInfo.isShowCall');
    var currentComponent = (0, _get3.default)(demoData, 'currentComponent');
    var isShowCall = isInConfigurationMode && currentComponent === 'call' || showCall;
    var callInfo = isInConfigurationMode ? demoData.callInfo : this.props.callInfo;

    var isAllowAccessMicrophone = callInfo.isAllowAccessMicrophone,
        isDeviceSupport = callInfo.isDeviceSupport,
        devices = callInfo.devices,
        selectedMicrophoneId = callInfo.selectedMicrophoneId,
        selectedSpeakerId = callInfo.selectedSpeakerId;
    var _props2 = this.props,
        isMobileMode = _props2.isMobileMode,
        iframeStyles = _props2.iframeStyles,
        setting = _props2.setting;

    var _calculateWidgetPosit = this.calculateWidgetPosition(),
        bottom = _calculateWidgetPosit.bottom,
        right = _calculateWidgetPosit.right,
        width = _calculateWidgetPosit.width;

    var status = isInConfigurationMode ? demoData.status : (0, _get3.default)(callInfo, 'callData.status');
    var isShowGetPermission = isInConfigurationMode ? status === _constants.CALL_STATUS.ACCESS_REQUEST : !isAllowAccessMicrophone;
    var isBorder = isShowGetPermission || (0, _includes3.default)([_constants.CALL_STATUS.START_CALL, _constants.CALL_STATUS.CONNECTING], status);
    var isStartCall = !status || (0, _includes3.default)([_constants.CALL_STATUS.START_CALL, _constants.CALL_STATUS.CONNECTING], status);
    var isLeftSite = (0, _get3.default)(setting, 'display.position') === 'LEFT_BOTTOM';
    var backgroundColor = (0, _includes3.default)([_constants.CALL_STATUS.INITIATED, _constants.CALL_STATUS.QUEUED, _constants.CALL_STATUS.RINGING, _constants.CALL_STATUS.IN_PROGRESS], status) ? (0, _get3.default)(setting, 'iconBackgroundColor') || '#fff' : '#fff';

    var renderWhenDeviceSupports = function renderWhenDeviceSupports() {
      return _react2.default.createElement(
        _layout2.default,
        {
          isShowCall: isShowCall,
          setting: setting,
          isMobileMode: isMobileMode,
          border: isBorder ? true : false,
          backgroundColor: backgroundColor,
          isLeftSite: isLeftSite
        },
        isShowGetPermission && _react2.default.createElement(_getPermission2.default, { handleGetPermission: _this3.handleGetPermission.bind(_this3), setting: setting, isMobileMode: isMobileMode }),
        isStartCall && _react2.default.createElement(_startCall2.default, {
          callInfo: callInfo,
          devices: devices,
          handleStartCall: _this3.handleStartCall.bind(_this3),
          handleSelectDevices: _this3.handleSelectDevices.bind(_this3),
          selectedMicrophoneId: selectedMicrophoneId,
          selectedSpeakerId: selectedSpeakerId,
          setting: setting,
          isMobileMode: isMobileMode
        }),
        (0, _includes3.default)([_constants.CALL_STATUS.INITIATED, _constants.CALL_STATUS.QUEUED, _constants.CALL_STATUS.RINGING], status) && _react2.default.createElement(_initCall2.default, { callInfo: callInfo, handleStopCall: _this3.handleStopCall.bind(_this3), setting: setting, isMobileMode: isMobileMode }),
        status === _constants.CALL_STATUS.IN_PROGRESS && _react2.default.createElement(_calling2.default, { callInfo: callInfo, handleStopCall: _this3.handleStopCall.bind(_this3), setting: setting, isMobileMode: isMobileMode }),
        (0, _includes3.default)([_constants.CALL_STATUS.BUSY, _constants.CALL_STATUS.ADMIN_CANCELED, _constants.CALL_STATUS.CUSTOMER_CANCELED, _constants.CALL_STATUS.NO_ANSWER, _constants.CALL_STATUS.BUSY_LEAVE_INFO, _constants.CALL_STATUS.FAILED], status) && _react2.default.createElement(_busyLine2.default, { status: status, setting: setting, handleCallAgain: _this3.handleStartCall.bind(_this3), isMobileMode: isMobileMode }),
        (0, _includes3.default)([_constants.CALL_STATUS.COMPLETED, _constants.CALL_STATUS.COMPLETED_RATING], status) && _react2.default.createElement(_complete2.default, {
          status: status,
          setting: setting,
          callInfo: callInfo,
          handleMakeAnotherCall: _this3.handleStartCall.bind(_this3),
          isMobileMode: isMobileMode
        }),
        status === _constants.CALL_STATUS.NO_SUPPORT && _react2.default.createElement(_noSupport2.default, { status: status, setting: setting, isMobileMode: isMobileMode })
      );
    };

    return _react2.default.createElement(
      _reactFrameComponent2.default,
      {
        ref: this.iframeRef,
        initialContent: '<!DOCTYPE html><html><head>          \n          <link href="https://fonts.googleapis.com/css?family=Comfortaa&display=swap" rel="stylesheet">\n          <link href="https://fonts.googleapis.com/css?family=Roboto&display=swap" rel="stylesheet">\n          <link href="https://fonts.googleapis.com/css2?family=Open+Sans&display=swap" rel="stylesheet">\n          <style>\n            .bs-chatbox-input-container .ant-upload {\n              display: flex !important;\n            }\n            .bs-call-form .ant-form-item-control {\n              line-height: 31px !important;\n            }\n          </style>\n          ' + iframeStyles + '</head><body></body></html>\n        ',
        mountTarget: 'body',
        allowtransparency: 'yes',
        style: (_ref4 = {
          right: isMobileMode ? 0 : right + 'px',
          bottom: isMobileMode ? 0 : bottom + 'px',
          position: isMobileMode ? 'fixed' : 'absolute',
          width: isMobileMode ? '100%' : width + 'px',
          minHeight: '468px',
          maxHeight: isMobileMode ? '100%' : '468px',
          opacity: isShowCall ? '1' : '0',
          transform: isShowCall ? 'scale(1, 1)' : 'scale(0, 0)',
          height: isMobileMode ? '100%' : 'calc(100% - ' + bottom + 'px)',
          zIndex: 9999999,
          transition: 'opacity 0.8s',
          overflow: 'hidden',
          transformOrigin: isSettingLeftBottom ? 'bottom left' : 'bottom right'
        }, _ref4['transition'] = 'transform 0.3s ease-in-out,opacity 0.3s ease-in-out , box-shadow 0.3s ease-in-out', _ref4.maxWidth = 'unset', _ref4),
        frameBorder: '0'
      },
      _react2.default.createElement(
        'div',
        { style: { width: '100%', height: '100%' } },
        !isDeviceSupport && _react2.default.createElement(
          _layout2.default,
          { setting: setting, isMobileMode: isMobileMode, backgroundColor: backgroundColor },
          _react2.default.createElement(_noSupport2.default, { status: status, setting: setting, isMobileMode: isMobileMode })
        ),
        isDeviceSupport && renderWhenDeviceSupports()
      )
    );
  };

  PhoneCall.prototype.render = function render() {
    var _this4 = this;

    var _props3 = this.props,
        iframeStyles = _props3.iframeStyles,
        position = _props3.position,
        setting = _props3.setting,
        svgSize = _props3.svgSize;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor;

    var iconSize = (0, _get3.default)(setting, 'iconSize');
    return _react2.default.createElement(
      'div',
      null,
      this.renderCallWidget(),
      _react2.default.createElement(
        _reactFrameComponent2.default,
        {
          initialContent: '<!DOCTYPE html><html><head>' + iframeStyles + '</head><body></body></html>',
          mountTarget: 'body',
          style: {
            width: iconSize,
            height: iconSize,
            position: 'absolute',
            bottom: position.bottom + 'px',
            right: position.right + 'px',
            transition: 'opacity 0.8s',
            zIndex: '9999997',
            maxWidth: iconSize,
            minWidth: iconSize,
            minHeight: iconSize,
            maxHeight: iconSize
          },
          allowtransparency: 'yes',
          frameBorder: '0'
        },
        _react2.default.createElement(_widgetIcon2.default, {
          iconBackgroundColor: iconBackgroundColor,
          iconSize: iconSize,
          iconSrc: _callWidget2.default,
          iconTextColor: iconTextColor,
          svgSize: svgSize,
          onClick: this.handleClickCall,
          handleHover: function handleHover(e) {
            return _this4.setState(e);
          }
        })
      ),
      this.state.isHover && _react2.default.createElement(_tooltip2.default, (0, _extends3.default)({}, this.props, this.state))
    );
  };

  return PhoneCall;
}(_react.Component);

exports.default = (0, _reactRedux.connect)(function (store) {
  return {
    callInfo: (0, _get3.default)(store, 'behavior.callInfo'),
    showChat: (0, _get3.default)(store, 'behavior.showChat')
  };
}, function (dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)({
      checkMediaDevice: _actions.checkMediaDevice,
      toggleCall: _actions.toggleCall,
      updateMediaPermission: _actions.updateMediaPermission,
      startCall: _actions.startCall,
      stopCall: _actions.stopCall,
      selectDevices: _actions.selectDevices
    }, dispatch)
  };
})(PhoneCall);
module.exports = exports['default'];