'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactFrameComponent = require('react-frame-component');

var _reactFrameComponent2 = _interopRequireDefault(_reactFrameComponent);

var _scroll_top = require('../icon/scroll_top.svg');

var _scroll_top2 = _interopRequireDefault(_scroll_top);

var _widgetIcon = require('../../commons/components/widget-icon');

var _widgetIcon2 = _interopRequireDefault(_widgetIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ScrollTop = function (_Component) {
  (0, _inherits3.default)(ScrollTop, _Component);

  function ScrollTop() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ScrollTop);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      visibile: false
    }, _this.handleClick = function () {
      var rootWindow = _this.props.rootWindow;

      var position = rootWindow.pageYOffset;
      // console.log("position", position);
      rootWindow && rootWindow.scrollTo({ top: 0, left: 0, behavior: 'smooth' });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  ScrollTop.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var _props = this.props,
        rootWindow = _props.rootWindow,
        rootDocument = _props.rootDocument;


    if (rootWindow) {
      var updateIconStatus = function updateIconStatus() {
        var scrollHeight = (0, _get3.default)(rootWindow, 'pageYOffset');
        var screenHeight = (0, _get3.default)(rootWindow, 'screen.height') || (0, _get3.default)(rootDocument, 'body.clientHeight');
        if (scrollHeight - screenHeight > 0) {
          _this2.setState({
            visibile: true
          });
        } else {
          _this2.setState({
            visibile: false
          });
        }
      };

      rootWindow.onscroll = function () {
        updateIconStatus();
      };

      if (rootWindow && rootDocument) {
        updateIconStatus();
      }
    }
  };

  ScrollTop.prototype.render = function render() {
    var _props2 = this.props,
        iframeStyles = _props2.iframeStyles,
        position = _props2.position,
        setting = _props2.setting,
        svgSize = _props2.svgSize;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor,
        isAlwayShowScrollTop = setting.isAlwayShowScrollTop;

    var iconSize = (0, _get3.default)(setting, 'iconSize');

    return isAlwayShowScrollTop || this.state.visibile ? _react2.default.createElement(
      _reactFrameComponent2.default,
      {
        initialContent: '<!DOCTYPE html><html><head>' + iframeStyles + '</head><body></body></html>',
        mountTarget: 'body',
        style: {
          width: iconSize,
          height: iconSize,
          position: 'absolute',
          bottom: position.bottom + 'px',
          right: position.right + 'px',
          transition: 'opacity 0.8s',
          zIndex: '9999997',
          maxWidth: iconSize,
          minWidth: iconSize,
          minHeight: iconSize,
          maxHeight: iconSize
        },
        allowtransparency: 'yes',
        frameBorder: '0'
      },
      _react2.default.createElement(_widgetIcon2.default, {
        iconBackgroundColor: iconBackgroundColor,
        iconSize: iconSize,
        iconSrc: _scroll_top2.default,
        iconTextColor: iconTextColor,
        svgSize: 20,
        onClick: this.handleClick
      })
    ) : _react2.default.createElement('div', { style: { display: 'none' } });
  };

  return ScrollTop;
}(_react.Component);

exports.default = ScrollTop;
module.exports = exports['default'];