'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactFrameComponent = require('react-frame-component');

var _reactFrameComponent2 = _interopRequireDefault(_reactFrameComponent);

var _collapse_widgets = require('../icon/collapse_widgets.svg');

var _collapse_widgets2 = _interopRequireDefault(_collapse_widgets);

var _support = require('../icon/support.svg');

var _support2 = _interopRequireDefault(_support);

var _widgetIcon = require('../../commons/components/widget-icon');

var _widgetIcon2 = _interopRequireDefault(_widgetIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Support = function (_Component) {
  (0, _inherits3.default)(Support, _Component);

  function Support(props) {
    (0, _classCallCheck3.default)(this, Support);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));

    _this.handleClick = function () {
      var _this$props = _this.props,
          t = _this$props.t,
          toggleCollapseExpandWidget = _this$props.toggleCollapseExpandWidget;

      toggleCollapseExpandWidget && toggleCollapseExpandWidget();
    };

    _this.myRef = _react2.default.createRef();
    _this.state = {
      widthText: 0
    };
    return _this;
  }

  Support.prototype.componentDidMount = function componentDidMount() {
    this.myRef.current && this.setState({ widthText: this.myRef.current.offsetWidth });
  };

  Support.prototype.render = function render() {
    var _props = this.props,
        iframeStyles = _props.iframeStyles,
        position = _props.position,
        setting = _props.setting,
        svgSize = _props.svgSize,
        isCurrentExpand = _props.isCurrentExpand,
        area = _props.area,
        showChat = _props.showChat,
        numberOfNewMessages = _props.numberOfNewMessages,
        marginBottom = _props.marginBottom,
        isSettingLeftBottom = _props.isSettingLeftBottom,
        marginLeft = _props.marginLeft,
        isFixedRect = _props.isFixedRect;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor;

    var iconSize = (0, _get3.default)(setting, 'iconSize');
    var isActive = (0, _get3.default)(setting, 'display.isActiveTextAction');
    var toolTipHeight = iconSize === 70 ? 44 : iconSize === 60 ? 38 : 36;
    var bottom = (iconSize - toolTipHeight) / 2 + marginBottom;
    var positionTextAction = isSettingLeftBottom ? { left: !isFixedRect ? -(position.right - 10) : marginLeft + iconSize + 10 } : { right: position.right + iconSize + 10 };
    var style = (0, _extends3.default)({
      padding: iconSize === 70 ? '11px 16px' : iconSize === 60 ? '8px 14px' : '7px 12px',
      boxShadow: '0 0 10px 0 rgba(0, 0, 0, 0.16)',
      backgroundColor: '#ffffff',
      position: 'absolute',
      bottom: bottom + 'px',
      fontFamily: 'OpenSans-Regular',
      fontSize: '16px',
      fontWeight: 'normal',
      fontStretch: 'normal',
      fontStyle: 'normal',
      letterSpacing: 'normal',
      textAlign: 'left',
      color: '#000000',
      minWidth: 'max-content'
    }, positionTextAction);
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactFrameComponent2.default,
        {
          initialContent: '<!DOCTYPE html><html><head>' + iframeStyles + '</head><body></body></html>',
          mountTarget: 'body',
          style: {
            width: iconSize,
            height: iconSize,
            position: 'absolute',
            bottom: position.bottom + 'px',
            right: position.right + 'px',
            transition: 'opacity 0.8s',
            zIndex: '9999997',
            maxWidth: iconSize,
            minWidth: iconSize,
            minHeight: iconSize,
            maxHeight: iconSize
          },
          allowtransparency: 'yes',
          frameBorder: '0'
        },
        _react2.default.createElement(_widgetIcon2.default, {
          iconBackgroundColor: iconBackgroundColor,
          iconSize: iconSize,
          iconSrc: isCurrentExpand ? _collapse_widgets2.default : _support2.default,
          iconTextColor: iconTextColor,
          svgSize: isCurrentExpand ? 16 : svgSize,
          onClick: this.handleClick,
          numberOfNewMessages: !isCurrentExpand && !showChat ? numberOfNewMessages : null
        })
      ),
      _react2.default.createElement(
        'div',
        null,
        isActive && !isCurrentExpand && _react2.default.createElement(
          'span',
          { ref: this.myRef, style: style },
          (0, _get3.default)(setting, 'display.textAction') || 'Need support?'
        )
      )
    );
  };

  return Support;
}(_react.Component);

exports.default = Support;
module.exports = exports['default'];