'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Tooltip = function (_Component) {
  (0, _inherits3.default)(Tooltip, _Component);

  function Tooltip(props) {
    (0, _classCallCheck3.default)(this, Tooltip);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));

    _this.myRef = _react2.default.createRef();
    _this.state = {
      widthText: 0
    };
    return _this;
  }

  Tooltip.prototype.componentDidMount = function componentDidMount() {
    this.getWidthTooltip();
  };

  Tooltip.prototype.componentDidUpdate = function componentDidUpdate() {
    this.getWidthTooltip();
  };

  Tooltip.prototype.getWidthTooltip = function getWidthTooltip() {
    if (this.myRef.current && +this.myRef.current.offsetWidth !== +this.state.widthText && (+this.myRef.current.offsetWidth > +this.state.widthText + 5 || +this.myRef.current.offsetWidth < +this.state.widthText - 5)) {
      this.setState({ widthText: +this.myRef.current.offsetWidth });
    }
  };

  Tooltip.prototype.render = function render() {
    var _props = this.props,
        type = _props.type,
        isSettingLeftBottom = _props.isSettingLeftBottom,
        position = _props.position,
        marginBottom = _props.marginBottom,
        setting = _props.setting,
        isHover = _props.isHover,
        isSettingVertical = _props.isSettingVertical,
        marginRight = _props.marginRight,
        index = _props.index;
    var widthText = this.state.widthText;

    var iconSize = (0, _get3.default)(setting, 'iconSize');
    var toolTipHeight = iconSize === 70 ? 44 : iconSize === 60 ? 38 : 36;
    var bottom = isSettingVertical ? (iconSize - toolTipHeight) / 2 + marginBottom + (iconSize + 10) * index : marginBottom + iconSize + 10;
    var positionTextAction = isSettingLeftBottom ? { right: isSettingVertical ? position.right - 10 - widthText : position.right - (widthText - iconSize) / 2 } : { right: isSettingVertical ? marginRight + iconSize + 10 : position.right - (widthText - iconSize) / 2 };
    var style = (0, _extends3.default)({
      padding: iconSize === 70 ? '11px 16px' : iconSize === 60 ? '8px 14px' : '7px 12px',
      boxShadow: '0 0 10px 0 rgba(0, 0, 0, 0.16)',
      backgroundColor: '#ffffff',
      position: 'absolute',
      bottom: bottom + 'px',
      fontFamily: 'OpenSans-Regular',
      fontSize: '16px',
      fontWeight: 'normal',
      fontStretch: 'normal',
      fontStyle: 'normal',
      letterSpacing: 'normal',
      textAlign: 'left',
      color: '#000000',
      minWidth: 'max-content'
    }, positionTextAction);
    return _react2.default.createElement(
      'span',
      { style: style, ref: this.myRef, className: 'tooltip' },
      type.charAt(0).toUpperCase() + type.slice(1)
    );
  };

  return Tooltip;
}(_react.Component);

exports.default = Tooltip;
module.exports = exports['default'];