'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _cloneDeep2 = require('lodash/cloneDeep');

var _cloneDeep3 = _interopRequireDefault(_cloneDeep2);

var _find2 = require('lodash/find');

var _find3 = _interopRequireDefault(_find2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _behavior = require('./store/reducers/behavior.reducer');

var _behavior2 = _interopRequireDefault(_behavior);

var _message = require('./store/reducers/message.reducer');

var _message2 = _interopRequireDefault(_message);

var _reduxDevtoolsExtension = require('redux-devtools-extension');

var _websocket = require('../src/connections/websocket');

var _widgetContext = require('./widget-context');

var _widgetContext2 = _interopRequireDefault(_widgetContext);

var _localStorage = require('./commons/utils/local-storage');

var _tenantInfo = require('./commons/tenant-info');

var _localStorage2 = require('./commons/constants/local-storage');

var _websiteEvents = require('./commons/constants/website-events');

var _websocket2 = require('./commons/constants/websocket');

var _startingPointTypes = require('./commons/constants/starting-point-types');

var _ws = require('./store/actions/ws.actions');

var _clearEndSlash = require('./commons/utils/clear-end-slash');

var _clearEndSlash2 = _interopRequireDefault(_clearEndSlash);

var _runFunAfter = require('./commons/utils/run-fun-after');

var _runFunAfter2 = _interopRequireDefault(_runFunAfter);

var _networkDetector = require('./commons/utils/network-detector');

var _startConversation = require('./store/actions/start-conversation.actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Widget = (0, _react.lazy)(function () {
  return import('./components/widget');
});
var Conversation = (0, _react.lazy)(function () {
  return import('./components/conversation');
});

var getHrefWithoutQueryAndParam = function getHrefWithoutQueryAndParam() {
  return '' + window.location.origin + window.location.pathname;
};

var getListStartingPoints = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(host, channelId, templateId) {
    var results, pageIndex, pageSize, totalReturnedItems, response, returnedItems;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            results = [];
            pageIndex = 1;
            pageSize = 10;
            totalReturnedItems = 0;

          case 4:
            _context.next = 6;
            return fetch(host + '/channel/website/starting-points?channelId=' + channelId + '&templateId=' + templateId + '&pageIndex=' + pageIndex, {
              method: 'GET'
            });

          case 6:
            response = _context.sent;

            ++pageIndex;
            _context.next = 10;
            return response.json();

          case 10:
            returnedItems = _context.sent;

            Array.from(returnedItems || []).forEach(function (item) {
              if (item.active) {
                results.push(item);
              }
            });
            totalReturnedItems = returnedItems.length;

          case 13:
            if (totalReturnedItems === pageSize) {
              _context.next = 4;
              break;
            }

          case 14:
            return _context.abrupt('return', results);

          case 15:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function getListStartingPoints(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

function findValidStartingPoint(startingPoints, type, opts) {
  for (var _iterator = startingPoints, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
    var _ref2;

    if (_isArray) {
      if (_i >= _iterator.length) break;
      _ref2 = _iterator[_i++];
    } else {
      _i = _iterator.next();
      if (_i.done) break;
      _ref2 = _i.value;
    }

    var startPoint = _ref2;

    if (type === _startingPointTypes.STARTING_POINT_TYPES.VISITOR_CLICK_ELEMENT) {
      var id = opts.id,
          className = opts.className;

      if (id && id === (0, _get3.default)(startPoint, 'detail.id')) return startPoint;
      if (className && className === (0, _get3.default)(startPoint, 'detail.className')) return startPoint;
    }

    if (type === _startingPointTypes.STARTING_POINT_TYPES.VISITOR_VISIT_URLS) {
      var _ret = function () {
        var url = opts.url;
        // console.log("url:", url);

        var requiredUrls = (0, _get3.default)(startPoint, 'detail.urls') || [];
        var lowercaseUrlWithoutEndSlash = toLower((0, _clearEndSlash2.default)(url));
        // console.log("lowercaseUrlWithoutEndSlash:", lowercaseUrlWithoutEndSlash);
        if ((0, _find3.default)(requiredUrls, function (defineUrl) {
          return toLower((0, _clearEndSlash2.default)(defineUrl)) === lowercaseUrlWithoutEndSlash;
        })) {
          // console.log("found starting point");
          return {
            v: startPoint
          };
        }
      }();

      if ((typeof _ret === 'undefined' ? 'undefined' : (0, _typeof3.default)(_ret)) === "object") return _ret.v;
    }
  }
  return null;
}

var ConnectedWidget = function (_React$Component) {
  (0, _inherits3.default)(ConnectedWidget, _React$Component);

  function ConnectedWidget(props) {
    (0, _classCallCheck3.default)(this, ConnectedWidget);

    var _this = (0, _possibleConstructorReturn3.default)(this, _React$Component.call(this, props));

    _this.networkChangesHandler = function (isOnline) {
      if (!isOnline) {
        (0, _websocket.disconnectWSClient)();
      } else {
        (0, _websocket.reconnectWSClient)();
      }
    };

    var _this$props = _this.props,
        isInConfigurationMode = _this$props.isInConfigurationMode,
        isSimulator = _this$props.isSimulator,
        onInitConversationSuccess = _this$props.onInitConversationSuccess,
        setting = _this$props.setting;
    var host = setting.host,
        tenantId = setting.tenantId,
        channelId = setting.channelId,
        automation = setting.automation;

    var isDisableLiveChat = !(0, _get3.default)(setting, 'chatboxComponent.enable');
    var isDisableCall = !(0, _get3.default)(setting, 'callComponent.enable');

    _this.state = {
      online: true,
      isReconnecting: false,
      isConnectFailed: false,
      iframeStylesInnerHtml: '',
      iframeStyles: ''
    };

    var reducer = (0, _redux.combineReducers)({ behavior: _behavior2.default, messages: _message2.default });
    if (isInConfigurationMode) {
      _this.store = (0, _redux.createStore)(function () {}, process.env.NODE_ENV !== 'production' ? (0, _reduxDevtoolsExtension.composeWithDevTools)((0, _redux.applyMiddleware)(_reduxThunk2.default)) : (0, _redux.applyMiddleware)(_reduxThunk2.default));
      return (0, _possibleConstructorReturn3.default)(_this);
    }

    var styleTag = props.pageDocument.head.querySelector('.boostcrm-stylesheet');
    if (styleTag) {
      var observer = new MutationObserver(function () {
        _this.setState({
          iframeStylesInnerHtml: _this.state.iframeStylesInnerHtml + styleTag.innerHTML,
          iframeStyles: '<style type="text/css" class="iframe-boostcrm">\n            .frame-content {\n              height: 100%;\n            }  \n            body {\n              font-family: \'Roboto !important\';\n            }\n            body {\n              background: none !important;\n              background-color: transparent !important;    \n              overflow:hidden\n            }\n            ' + (_this.state.iframeStylesInnerHtml + styleTag.innerHTML) + '\n          </style>'
        });
        styleTag.innerHTML = '';
      });
      observer.observe(styleTag, { characterData: false, childList: true, attributes: false });
    }

    (0, _tenantInfo.setTenantId)(tenantId);
    (0, _tenantInfo.setChannelId)(channelId);
    (0, _localStorage.setLSVariable)((0, _localStorage2.getLocalStorageVariables)(_localStorage2.LOCAL_STORAGE_VARIABLES.IS_SIMULATOR, channelId), isSimulator);
    var persistentState = (0, _localStorage.getLSVariable)((0, _localStorage2.getLocalStorageVariables)(_localStorage2.LOCAL_STORAGE_VARIABLES.STORE_STATE, channelId));
    (0, _localStorage.setLSVariable)((0, _localStorage2.getLocalStorageVariables)(_localStorage2.LOCAL_STORAGE_VARIABLES.CHANNEL_ID, channelId), channelId);
    (0, _localStorage.setLSVariable)((0, _localStorage2.getLocalStorageVariables)(_localStorage2.LOCAL_STORAGE_VARIABLES.TENANT_ID, channelId), tenantId);
    (0, _localStorage.setLSVariable)((0, _localStorage2.getLocalStorageVariables)(_localStorage2.LOCAL_STORAGE_VARIABLES.HOST, channelId), host);

    if (isSimulator) {
      persistentState = {};
    }
    if ((0, _get3.default)(persistentState, ['behavior', 'callInfo', 'callData'])) {
      persistentState.behavior.callInfo.callData = null;
    }
    _this.store = (0, _redux.createStore)(reducer, persistentState || {}, process.env.NODE_ENV !== 'production' ? (0, _reduxDevtoolsExtension.composeWithDevTools)((0, _redux.applyMiddleware)(_reduxThunk2.default)) : (0, _redux.applyMiddleware)(_reduxThunk2.default));

    if (_this.store) {
      _this.store.subscribe(function () {
        var data = (0, _cloneDeep3.default)(_this.store.getState());
        (0, _localStorage.setLSVariable)((0, _localStorage2.getLocalStorageVariables)(_localStorage2.LOCAL_STORAGE_VARIABLES.STORE_STATE, channelId), data);
      });
    }

    if (!isSimulator && isDisableCall && isDisableLiveChat) return (0, _possibleConstructorReturn3.default)(_this);

    (0, _websocket.initWSClient)(host, _this.props.setting.channelToken, channelId, isSimulator, null, function (newConversationId) {
      // console.log("Start new conversation: ", newConversationId);
      (0, _tenantInfo.setConversationId)(newConversationId);
      newConversationId && onInitConversationSuccess && onInitConversationSuccess(newConversationId);
    }, function () {
      console.log('set online false 1');
      _this.setState({
        online: false,
        isConnectFailed: true,
        isReconnecting: false
      });
    }, function () {
      console.log('set online false 2');
      _this.setState({
        online: false,
        isConnectFailed: false,
        isReconnecting: true
      });
    }, function () {
      console.log('set online true');
      _this.setState({
        online: true,
        isConnectFailed: false,
        isReconnecting: false
      });
    });

    (0, _websocket.setMessageHanlder)(function (message) {
      var actionType = 'WS_' + (0, _get3.default)(message, 'group') + '_' + (0, _get3.default)(message, 'type');
      _this.store.dispatch({
        type: actionType,
        payload: message.payload
      });

      if ((0, _get3.default)(message, 'group') === _websocket2.GROUP.MESSAGE && (0, _get3.default)(message, 'type') === _websocket2.TYPE.MESSAGE.NEW_MESSAGE_FROM_ADMIN) {
        _this.store.dispatch((0, _ws.sendAckReceivingMessage)(message.payload, channelId));
      }
    });

    if (!isSimulator) {
      (0, _websocket.sendWebsiteEvent)(_websiteEvents.WEBSITE_EVENTS.VISIT_URL, {
        url: getHrefWithoutQueryAndParam(),
        loadDate: new Date(),
        tenantInfo: { channelId: channelId }
      });

      (0, _runFunAfter2.default)(function () {
        _this.store.dispatch && _this.store.dispatch((0, _startConversation.triggerTheWelcomeMessageWhenVisitPage)(setting));
      }, 1000);

      // Get list of starting points here.

      var _ref3 = automation || {},
          enabled = _ref3.enabled,
          templateId = _ref3.templateId;

      if (enabled && templateId) {
        getListStartingPoints(host, setting.channelId, templateId).then(function (startingPoints) {
          if (startingPoints.length === 0) return;

          // Check if needed to trigger event 'visit-urls'
          var startingPointForVisitURLs = findValidStartingPoint(startingPoints, _startingPointTypes.STARTING_POINT_TYPES.VISITOR_VISIT_URLS, {
            url: getHrefWithoutQueryAndParam()
          });

          startingPointForVisitURLs && (0, _runFunAfter2.default)(function () {
            _this.store.dispatch && _this.store.dispatch((0, _startConversation.triggerTheStartingPoint)(_startingPointTypes.STARTING_POINT_TYPES.VISITOR_VISIT_URLS, startingPointForVisitURLs.id, setting));
          }, 1000);

          var pageDocument = props.pageDocument;

          if (pageDocument) {
            pageDocument.addEventListener('click', function (e) {
              if (!e) return;
              var toElement = e.toElement;
              if (!toElement) return;
              var id = toElement.id;
              var className = toElement.className;
              var validStartPoint = findValidStartingPoint(startingPoints, _startingPointTypes.STARTING_POINT_TYPES.VISITOR_CLICK_ELEMENT, {
                id: id,
                className: className
              });
              validStartPoint && _this.store.dispatch && _this.store.dispatch((0, _startConversation.triggerTheStartingPoint)(_startingPointTypes.STARTING_POINT_TYPES.VISITOR_CLICK_ELEMENT, validStartPoint.id, setting));
            }, true);
          }
        });
      }
    }
    return _this;
  }

  ConnectedWidget.prototype.componentWillUnmount = function componentWillUnmount() {
    (0, _websocket.closeWSClient)();
  };

  ConnectedWidget.prototype.render = function render() {
    var _props = this.props,
        setting = _props.setting,
        isSimulator = _props.isSimulator,
        isInConfigurationMode = _props.isInConfigurationMode;
    var _state = this.state,
        online = _state.online,
        isReconnecting = _state.isReconnecting,
        isConnectFailed = _state.isConnectFailed,
        iframeStyles = _state.iframeStyles;

    return _react2.default.createElement(
      _reactRedux.Provider,
      { store: this.store },
      _react2.default.createElement(
        _widgetContext2.default.Provider,
        {
          value: {
            setting: setting,
            isSimulator: isSimulator,
            online: online,
            isReconnecting: isReconnecting,
            isConnectFailed: isConnectFailed,
            isInConfigurationMode: isInConfigurationMode
          }
        },
        isSimulator && _react2.default.createElement(
          _react.Suspense,
          { fallback: _react2.default.createElement('div', null) },
          _react2.default.createElement(Conversation, (0, _extends3.default)({
            online: online,
            isReconnecting: isReconnecting,
            isConnectFailed: isConnectFailed,
            isSimulator: true,
            isMobileMode: true,
            iframeStyles: iframeStyles,
            rect: { width: 500, height: 600 }
          }, this.props))
        ),
        !isSimulator && _react2.default.createElement(
          _react.Suspense,
          { fallback: _react2.default.createElement('div', null) },
          _react2.default.createElement(Widget, (0, _extends3.default)({}, this.props, { iframeStyles: iframeStyles, rootWindow: window, rootDocument: document }))
        ),
        _react2.default.createElement(_networkDetector.NetworkDetector, { onChange: this.networkChangesHandler })
      )
    );
  };

  return ConnectedWidget;
}(_react2.default.Component);

exports.default = ConnectedWidget;
module.exports = exports['default'];