'use strict';

exports.__esModule = true;
exports.selectDevices = exports.updateMediaPermission = exports.toggleTheSupportWidgetRequest = exports.toggleChatRequest = exports.onScrollToBottom = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

exports.toggleChat = toggleChat;
exports.toggleCall = toggleCall;
exports.settingSound = settingSound;

var _actionType = require('./action-type');

var actions = _interopRequireWildcard(_actionType);

var _reduxActions = require('redux-actions');

var _websocket = require('../../connections/websocket');

var _websocket2 = require('../../commons/constants/websocket');

var _tenantInfo = require('../../commons/tenant-info');

var _startConversation = require('./start-conversation.actions');

var _utils = require('../../commons/utils');

var _getTimeDuration = require('../../commons/utils/get-time-duration');

var _getTimeDuration2 = _interopRequireDefault(_getTimeDuration);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var onScrollToBottom = exports.onScrollToBottom = (0, _reduxActions.createAction)(actions.ON_SCROLL_TO_BOTTOM);
var toggleChatRequest = exports.toggleChatRequest = (0, _reduxActions.createAction)(actions.TOGGLE_CHAT + '.REQUEST');

var toggleTheSupportWidgetRequest = exports.toggleTheSupportWidgetRequest = (0, _reduxActions.createAction)(actions.TOGGLE_SUPPORT_WIDGET + '.REQUEST');

function toggleChat(setting) {
  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(dispatch, getState) {
      var showChat, state, hasTriggeredWelcomeMessage, alreadyStartConversation, delay;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              showChat = (0, _get3.default)(state, 'behavior.showChat');

              dispatch(toggleChatRequest(!showChat));

              if (setting.isEnableAutomation) {
                _context.next = 5;
                break;
              }

              console.log('Ingore because not enable bot now');
              return _context.abrupt('return');

            case 5:
              if (!showChat) {
                _context.next = 7;
                break;
              }

              return _context.abrupt('return');

            case 7:
              state = getState();
              hasTriggeredWelcomeMessage = (0, _get3.default)(state, 'behavior.hasTriggeredWelcomeMessage');
              alreadyStartConversation = (0, _get3.default)(state, 'behavior.alreadyStartConversation');

              if (!(!(0, _utils.isDisablePreChatForm)(setting) && !alreadyStartConversation)) {
                _context.next = 13;
                break;
              }

              console.log('Ingore because the pre-chat form is enable & the conversation has not started');
              return _context.abrupt('return');

            case 13:
              if (!(!(0, _utils.isTriggerWelcomeMessageWhenClickIcon)(setting) && !(0, _utils.isTriggerWelcomeBackMessageWhenClickIcon)(setting))) {
                _context.next = 16;
                break;
              }

              console.log('Ingore because dont enable welcome message & welcome back message when revisit');
              return _context.abrupt('return');

            case 16:
              if (!((0, _utils.isTriggerWelcomeMessageWhenClickIcon)(setting) && !hasTriggeredWelcomeMessage)) {
                _context.next = 20;
                break;
              }

              (0, _websocket.sendMessage)({
                group: _websocket2.GROUP.MESSAGE,
                type: _websocket2.TYPE.MESSAGE.TRIGGER_WELCOME_MESSAGE,
                payload: {},
                tenantInfo: (0, _tenantInfo.getTenantInfo)()
              });
              dispatch((0, _startConversation.updateHasTriggeredWelcomeMessage)());
              return _context.abrupt('return');

            case 20:
              if (!(hasTriggeredWelcomeMessage && (0, _utils.isTriggerWelcomeBackMessageWhenClickIcon)(setting))) {
                _context.next = 25;
                break;
              }

              delay = (0, _getTimeDuration2.default)((0, _get3.default)(setting, 'screenWelcomeBackMessages.trigger.time'), (0, _get3.default)(setting, 'screenWelcomeBackMessages.trigger.unitOfTime'));

              console.log('...Trigger the welcome back message when click if:', delay);
              if ((0, _utils.isLastTimeMoreThanAPeriod)((0, _get3.default)(state, 'behavior.lastTimeTriggeredWelcomeMessage'), delay)) {
                console.log('Trigger the welcome back message');
                (0, _websocket.sendMessage)({
                  group: _websocket2.GROUP.MESSAGE,
                  type: _websocket2.TYPE.MESSAGE.TRIGGER_WELCOME_BACK_MESSAGE,
                  payload: {},
                  tenantInfo: (0, _tenantInfo.getTenantInfo)()
                });
                dispatch((0, _startConversation.updateHasTriggeredWelcomeMessage)());
              }
              return _context.abrupt('return');

            case 25:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
}

function toggleCall() {
  return {
    type: actions.TOGGLE_CALL
  };
}

function settingSound() {
  return {
    type: actions.SOUND_SETTING
  };
}

var updateMediaPermission = exports.updateMediaPermission = (0, _reduxActions.createAction)(actions.UPDATE_MEDIA_PERMISSION + '.REQUEST');

var selectDevices = exports.selectDevices = (0, _reduxActions.createAction)(actions.SELECT_DEVICE + '.REQUEST');