'use strict';

exports.__esModule = true;
exports.checkMediaDevice = exports.checkMediaDeviceSuccess = exports.checkMediaDeviceRequest = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _actionType = require('./action-type');

var actions = _interopRequireWildcard(_actionType);

var _reduxActions = require('redux-actions');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getDeviceList(cb) {
  // console.log("getDeviceList");
  try {
    var gotDevices = function gotDevices(devices) {
      // console.log("gotDevices: ", JSON.stringify(devices));
      cb(devices || []);
    };

    var handleError = function handleError(error) {
      // console.log("gotDevices-handleError: ", error);
      cb([]);
    };

    navigator.mediaDevices.enumerateDevices().then(gotDevices).catch(handleError);
  } catch (ex) {
    cb([]);
  }
}

var checkMediaDeviceRequest = exports.checkMediaDeviceRequest = (0, _reduxActions.createAction)(actions.CHECK_MEDIA_DEVICE + '.REQUEST');

var checkMediaDeviceSuccess = exports.checkMediaDeviceSuccess = (0, _reduxActions.createAction)(actions.CHECK_MEDIA_DEVICE + '.SUCCESS');

var checkMediaDevice = exports.checkMediaDevice = function checkMediaDevice() {
  // console.log("checkMediaDevice");
  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(dispatch, store) {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return dispatch(checkMediaDeviceRequest());

            case 2:
              getDeviceList(function (devices) {
                var totalAudioInput = 0;
                var totalAudioOutput = 0;
                var isAllowAcessMedia = false;
                for (var _iterator = devices, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
                  var _ref2;

                  if (_isArray) {
                    if (_i >= _iterator.length) break;
                    _ref2 = _iterator[_i++];
                  } else {
                    _i = _iterator.next();
                    if (_i.done) break;
                    _ref2 = _i.value;
                  }

                  var device = _ref2;

                  var _ref3 = device || {},
                      kind = _ref3.kind,
                      label = _ref3.label;

                  if (kind === 'audioinput') {
                    totalAudioInput++;
                  }

                  if (kind === 'audiooutput') {
                    totalAudioOutput++;
                  }

                  if (!isAllowAcessMedia && !(0, _isEmpty3.default)(label)) {
                    isAllowAcessMedia = true;
                  }
                }

                dispatch(checkMediaDeviceSuccess({
                  totalAudioInput: totalAudioInput,
                  totalAudioOutput: totalAudioOutput,
                  devices: devices,
                  isAllowAcessMedia: isAllowAcessMedia
                }));
              });

            case 3:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};