'use strict';

exports.__esModule = true;
exports.startCall = exports.startCallError = exports.startCallSuccess = exports.startCallRequest = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _isArray2 = require('lodash/isArray');

var _isArray3 = _interopRequireDefault(_isArray2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _actionType = require('./action-type');

var actions = _interopRequireWildcard(_actionType);

var _reduxActions = require('redux-actions');

var _websocket = require('../../connections/websocket');

var _websocket2 = require('../../commons/constants/websocket');

var _tenantInfo = require('../../commons/tenant-info');

var _utils = require('../../commons/utils');

var _webrtc = require('../../components/phone-call/webrtc');

var _webrtc2 = _interopRequireDefault(_webrtc);

var _getClientInfo = require('../../commons/utils/get-client-info');

var _getClientInfo2 = _interopRequireDefault(_getClientInfo);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var startCallRequest = exports.startCallRequest = (0, _reduxActions.createAction)(actions.START_CALL + '.REQUEST');
var startCallSuccess = exports.startCallSuccess = (0, _reduxActions.createAction)(actions.START_CALL + '.SUCCESS');
var startCallError = exports.startCallError = (0, _reduxActions.createAction)(actions.START_CALL + '.ERROR');
var startCall = exports.startCall = function startCall(device) {
  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(dispatch, getState) {
      var tenantInfo, _ref2, error, peerConnectionInfo;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return dispatch(startCallRequest({ device: device }));

            case 2:
              tenantInfo = (0, _tenantInfo.getTenantInfo)();

              // Request ICE Server

              (0, _websocket.sendMessage)({
                group: _websocket2.GROUP.CALL,
                type: _websocket2.TYPE.CALL.REQUEST_ICE_SERVERS,
                tenantInfo: tenantInfo
              });
              _context.prev = 4;
              _context.next = 7;
              return (0, _utils.retryFuncWithFibonancies)(function () {
                // console.log("Trying to connect to server");
                // To test what happen if could not get ice server
                // return false;
                var iceServers = (0, _get3.default)(getState(), 'behavior.callInfo.callData.iceServers');
                // console.log("iceServers: ", iceServers);
                var result = (0, _isArray3.default)(iceServers) && !(0, _isEmpty3.default)(iceServers);
                return result;
              }, [0.5, 1, 2, 3, 5, 8]);

            case 7:
              _context.next = 9;
              return _webrtc2.default.startCall((0, _get3.default)(getState(), 'behavior.callInfo.callData.iceServers'));

            case 9:
              _ref2 = _context.sent;
              error = _ref2[0];
              peerConnectionInfo = _ref2[1];

              if (error) {
                _context.next = 26;
                break;
              }

              _context.t0 = _websocket.sendMessage;
              _context.t1 = _websocket2.GROUP.CALL;
              _context.t2 = _websocket2.TYPE.CALL.START_CALL;
              _context.t3 = peerConnectionInfo;
              _context.next = 19;
              return (0, _getClientInfo2.default)();

            case 19:
              _context.t4 = _context.sent;
              _context.t5 = {
                peerConnectionInfo: _context.t3,
                callerInfo: _context.t4
              };
              _context.t6 = tenantInfo;
              _context.t7 = {
                group: _context.t1,
                type: _context.t2,
                payload: _context.t5,
                tenantInfo: _context.t6
              };
              (0, _context.t0)(_context.t7);
              _context.next = 28;
              break;

            case 26:
              _context.next = 28;
              return dispatch(startCallError({ error: 'Could not establish the connection' }));

            case 28:
              _context.next = 34;
              break;

            case 30:
              _context.prev = 30;
              _context.t8 = _context['catch'](4);
              _context.next = 34;
              return dispatch(startCallError({ error: 'Could not connect to server' }));

            case 34:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[4, 30]]);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};