'use strict';

exports.__esModule = true;
exports.stopCall = exports.stopCallRequest = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _actionType = require('./action-type');

var actions = _interopRequireWildcard(_actionType);

var _reduxActions = require('redux-actions');

var _websocket = require('../../connections/websocket');

var _websocket2 = require('../../commons/constants/websocket');

var _tenantInfo = require('../../commons/tenant-info');

var _webrtc = require('../../components/phone-call/webrtc');

var _webrtc2 = _interopRequireDefault(_webrtc);

var _constants = require('../../components/phone-call/constants');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var stopCallRequest = exports.stopCallRequest = (0, _reduxActions.createAction)(actions.STOP_CALL + '.REQUEST');
var stopCall = exports.stopCall = function stopCall(callInfo, _ref) {
  var stopReason = _ref.stopReason,
      totalDuration = _ref.totalDuration;

  return function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(dispatch) {
      var payload;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // webRTC stop call
              _webrtc2.default.stopCall();

              if ((0, _get3.default)(callInfo, 'id')) {
                _context.next = 3;
                break;
              }

              return _context.abrupt('return');

            case 3:
              payload = (0, _extends3.default)({}, callInfo, {
                stopReason: stopReason,
                totalDuration: stopReason === _constants.CALL_STOP_REASON.SUBSCRIBER_AUTO_STOP_WHEN_TIMEOUT ? 0 : totalDuration,
                status: stopReason === _constants.CALL_STOP_REASON.SUBSCRIBER_AUTO_STOP_WHEN_TIMEOUT || callInfo.status !== _constants.CALL_STATUS.IN_PROGRESS ? _constants.CALL_STATUS.CUSTOMER_CANCELED : _constants.CALL_STATUS.COMPLETED
              });


              dispatch(stopCallRequest({ status: payload.status }));
              (0, _websocket.sendMessage)({
                group: _websocket2.GROUP.CALL,
                type: _websocket2.TYPE.CALL.STOP_CALL,
                payload: payload,
                tenantInfo: (0, _tenantInfo.getTenantInfo)()
              });

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x) {
      return _ref2.apply(this, arguments);
    };
  }();
};