'use strict';

exports.__esModule = true;
exports.sendAckReceivingMessage = exports.receiveICEServerResponse = exports.receiveUpdateCallStatus = exports.receiveCreatedMessageNotification = exports.receiveMessageFromAdmin = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _reduxActions = require('redux-actions');

var _websocket = require('../../commons/constants/websocket');

var _tenantInfo = require('../../commons/tenant-info');

var _websocket2 = require('../../connections/websocket');

var _messageStatus = require('../../commons/constants/message-status');

var _message = require('../actions/message.actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var receiveMessageFromAdmin = exports.receiveMessageFromAdmin = (0, _reduxActions.createAction)('WS_' + _websocket.GROUP.MESSAGE + '_' + _websocket.TYPE.MESSAGE.NEW_MESSAGE_FROM_ADMIN);

var receiveCreatedMessageNotification = exports.receiveCreatedMessageNotification = (0, _reduxActions.createAction)('WS_' + _websocket.GROUP.MESSAGE + '_' + _websocket.TYPE.MESSAGE.CREATED_MESSAGE);

var receiveUpdateCallStatus = exports.receiveUpdateCallStatus = (0, _reduxActions.createAction)('WS_' + _websocket.GROUP.CALL + '_' + _websocket.TYPE.CALL.RECEIVE_UPDATE_CALL_STATUS);

var receiveICEServerResponse = exports.receiveICEServerResponse = (0, _reduxActions.createAction)('WS_' + _websocket.GROUP.CALL + '_' + _websocket.TYPE.CALL.REQUEST_ICE_SERVERS_RES);

// Emit message status after received
var sendAckReceivingMessage = exports.sendAckReceivingMessage = function sendAckReceivingMessage(payload, channelId) {
  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(dispatch, getState) {
      var showChat;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // console.log('sendAckReceivingMessage: 1', payload, channelId);
              showChat = (0, _get3.default)(getState(), 'behavior.showChat');

              if (document.hidden === false && showChat) {
                _sendMessage((0, _extends3.default)({}, payload, { status: _messageStatus.MESSAGE_STATUS.READ }), getState(), channelId);
                dispatch((0, _message.resetNumberOfNewMessages)());
              } else {
                _sendMessage((0, _extends3.default)({}, payload, { status: _messageStatus.MESSAGE_STATUS.DELIVERIED }), getState(), channelId);
                // Call function listen event visibilityChange
                _handleVisibilityChange(payload, getState(), channelId, dispatch);
              }

            case 2:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

var _sendMessage = function _sendMessage(payload) {
  (0, _websocket2.sendMessage)({
    group: _websocket.GROUP.MESSAGE,
    type: _websocket.TYPE.MESSAGE.UPDATE_MESSAGE_STATUS,
    payload: payload,
    tenantInfo: (0, _tenantInfo.getTenantInfo)()
  });
};

var _handleVisibilityChange = function _handleVisibilityChange(payload, store, channelId, dispatch) {
  // console.log('_handleVisibilityChange', payload);
  var showChat = (0, _get3.default)(store, 'behavior.showChat');
  function handleVisibilityChange() {
    if (!document.hidden && showChat) {
      _sendMessage((0, _extends3.default)({}, payload, { status: _messageStatus.MESSAGE_STATUS.READ }), store, channelId);
      dispatch((0, _message.resetNumberOfNewMessages)());
    }
  }
  document.addEventListener('visibilitychange', handleVisibilityChange, {
    once: true
  });
};